/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatabricksAlertV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#custom_description DataDatabricksAlertV2#custom_description}
    */
    readonly customDescription?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#custom_summary DataDatabricksAlertV2#custom_summary}
    */
    readonly customSummary?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#display_name DataDatabricksAlertV2#display_name}
    */
    readonly displayName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#evaluation DataDatabricksAlertV2#evaluation}
    */
    readonly evaluation?: DataDatabricksAlertV2Evaluation;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#parent_path DataDatabricksAlertV2#parent_path}
    */
    readonly parentPath?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#query_text DataDatabricksAlertV2#query_text}
    */
    readonly queryText?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#run_as_user_name DataDatabricksAlertV2#run_as_user_name}
    */
    readonly runAsUserName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#schedule DataDatabricksAlertV2#schedule}
    */
    readonly schedule?: DataDatabricksAlertV2Schedule;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#warehouse_id DataDatabricksAlertV2#warehouse_id}
    */
    readonly warehouseId?: string;
}
export interface DataDatabricksAlertV2EvaluationNotificationSubscriptions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#destination_id DataDatabricksAlertV2#destination_id}
    */
    readonly destinationId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#user_email DataDatabricksAlertV2#user_email}
    */
    readonly userEmail?: string;
}
export declare function dataDatabricksAlertV2EvaluationNotificationSubscriptionsToTerraform(struct?: DataDatabricksAlertV2EvaluationNotificationSubscriptions | cdktf.IResolvable): any;
export declare function dataDatabricksAlertV2EvaluationNotificationSubscriptionsToHclTerraform(struct?: DataDatabricksAlertV2EvaluationNotificationSubscriptions | cdktf.IResolvable): any;
export declare class DataDatabricksAlertV2EvaluationNotificationSubscriptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksAlertV2EvaluationNotificationSubscriptions | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertV2EvaluationNotificationSubscriptions | cdktf.IResolvable | undefined);
    private _destinationId?;
    get destinationId(): string;
    set destinationId(value: string);
    resetDestinationId(): void;
    get destinationIdInput(): string | undefined;
    private _userEmail?;
    get userEmail(): string;
    set userEmail(value: string);
    resetUserEmail(): void;
    get userEmailInput(): string | undefined;
}
export declare class DataDatabricksAlertV2EvaluationNotificationSubscriptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksAlertV2EvaluationNotificationSubscriptions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksAlertV2EvaluationNotificationSubscriptionsOutputReference;
}
export interface DataDatabricksAlertV2EvaluationNotification {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#notify_on_ok DataDatabricksAlertV2#notify_on_ok}
    */
    readonly notifyOnOk?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#retrigger_seconds DataDatabricksAlertV2#retrigger_seconds}
    */
    readonly retriggerSeconds?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#subscriptions DataDatabricksAlertV2#subscriptions}
    */
    readonly subscriptions?: DataDatabricksAlertV2EvaluationNotificationSubscriptions[] | cdktf.IResolvable;
}
export declare function dataDatabricksAlertV2EvaluationNotificationToTerraform(struct?: DataDatabricksAlertV2EvaluationNotification | cdktf.IResolvable): any;
export declare function dataDatabricksAlertV2EvaluationNotificationToHclTerraform(struct?: DataDatabricksAlertV2EvaluationNotification | cdktf.IResolvable): any;
export declare class DataDatabricksAlertV2EvaluationNotificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertV2EvaluationNotification | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertV2EvaluationNotification | cdktf.IResolvable | undefined);
    private _notifyOnOk?;
    get notifyOnOk(): boolean | cdktf.IResolvable;
    set notifyOnOk(value: boolean | cdktf.IResolvable);
    resetNotifyOnOk(): void;
    get notifyOnOkInput(): boolean | cdktf.IResolvable | undefined;
    private _retriggerSeconds?;
    get retriggerSeconds(): number;
    set retriggerSeconds(value: number);
    resetRetriggerSeconds(): void;
    get retriggerSecondsInput(): number | undefined;
    private _subscriptions;
    get subscriptions(): DataDatabricksAlertV2EvaluationNotificationSubscriptionsList;
    putSubscriptions(value: DataDatabricksAlertV2EvaluationNotificationSubscriptions[] | cdktf.IResolvable): void;
    resetSubscriptions(): void;
    get subscriptionsInput(): cdktf.IResolvable | DataDatabricksAlertV2EvaluationNotificationSubscriptions[] | undefined;
}
export interface DataDatabricksAlertV2EvaluationSource {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#aggregation DataDatabricksAlertV2#aggregation}
    */
    readonly aggregation?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#display DataDatabricksAlertV2#display}
    */
    readonly display?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#name DataDatabricksAlertV2#name}
    */
    readonly name?: string;
}
export declare function dataDatabricksAlertV2EvaluationSourceToTerraform(struct?: DataDatabricksAlertV2EvaluationSource | cdktf.IResolvable): any;
export declare function dataDatabricksAlertV2EvaluationSourceToHclTerraform(struct?: DataDatabricksAlertV2EvaluationSource | cdktf.IResolvable): any;
export declare class DataDatabricksAlertV2EvaluationSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertV2EvaluationSource | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertV2EvaluationSource | cdktf.IResolvable | undefined);
    private _aggregation?;
    get aggregation(): string;
    set aggregation(value: string);
    resetAggregation(): void;
    get aggregationInput(): string | undefined;
    private _display?;
    get display(): string;
    set display(value: string);
    resetDisplay(): void;
    get displayInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataDatabricksAlertV2EvaluationThresholdColumn {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#aggregation DataDatabricksAlertV2#aggregation}
    */
    readonly aggregation?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#display DataDatabricksAlertV2#display}
    */
    readonly display?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#name DataDatabricksAlertV2#name}
    */
    readonly name?: string;
}
export declare function dataDatabricksAlertV2EvaluationThresholdColumnToTerraform(struct?: DataDatabricksAlertV2EvaluationThresholdColumn | cdktf.IResolvable): any;
export declare function dataDatabricksAlertV2EvaluationThresholdColumnToHclTerraform(struct?: DataDatabricksAlertV2EvaluationThresholdColumn | cdktf.IResolvable): any;
export declare class DataDatabricksAlertV2EvaluationThresholdColumnOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertV2EvaluationThresholdColumn | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertV2EvaluationThresholdColumn | cdktf.IResolvable | undefined);
    private _aggregation?;
    get aggregation(): string;
    set aggregation(value: string);
    resetAggregation(): void;
    get aggregationInput(): string | undefined;
    private _display?;
    get display(): string;
    set display(value: string);
    resetDisplay(): void;
    get displayInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataDatabricksAlertV2EvaluationThresholdValue {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#bool_value DataDatabricksAlertV2#bool_value}
    */
    readonly boolValue?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#double_value DataDatabricksAlertV2#double_value}
    */
    readonly doubleValue?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#string_value DataDatabricksAlertV2#string_value}
    */
    readonly stringValue?: string;
}
export declare function dataDatabricksAlertV2EvaluationThresholdValueToTerraform(struct?: DataDatabricksAlertV2EvaluationThresholdValue | cdktf.IResolvable): any;
export declare function dataDatabricksAlertV2EvaluationThresholdValueToHclTerraform(struct?: DataDatabricksAlertV2EvaluationThresholdValue | cdktf.IResolvable): any;
export declare class DataDatabricksAlertV2EvaluationThresholdValueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertV2EvaluationThresholdValue | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertV2EvaluationThresholdValue | cdktf.IResolvable | undefined);
    private _boolValue?;
    get boolValue(): boolean | cdktf.IResolvable;
    set boolValue(value: boolean | cdktf.IResolvable);
    resetBoolValue(): void;
    get boolValueInput(): boolean | cdktf.IResolvable | undefined;
    private _doubleValue?;
    get doubleValue(): number;
    set doubleValue(value: number);
    resetDoubleValue(): void;
    get doubleValueInput(): number | undefined;
    private _stringValue?;
    get stringValue(): string;
    set stringValue(value: string);
    resetStringValue(): void;
    get stringValueInput(): string | undefined;
}
export interface DataDatabricksAlertV2EvaluationThreshold {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#column DataDatabricksAlertV2#column}
    */
    readonly column?: DataDatabricksAlertV2EvaluationThresholdColumn;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#value DataDatabricksAlertV2#value}
    */
    readonly value?: DataDatabricksAlertV2EvaluationThresholdValue;
}
export declare function dataDatabricksAlertV2EvaluationThresholdToTerraform(struct?: DataDatabricksAlertV2EvaluationThreshold | cdktf.IResolvable): any;
export declare function dataDatabricksAlertV2EvaluationThresholdToHclTerraform(struct?: DataDatabricksAlertV2EvaluationThreshold | cdktf.IResolvable): any;
export declare class DataDatabricksAlertV2EvaluationThresholdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertV2EvaluationThreshold | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertV2EvaluationThreshold | cdktf.IResolvable | undefined);
    private _column;
    get column(): DataDatabricksAlertV2EvaluationThresholdColumnOutputReference;
    putColumn(value: DataDatabricksAlertV2EvaluationThresholdColumn): void;
    resetColumn(): void;
    get columnInput(): cdktf.IResolvable | DataDatabricksAlertV2EvaluationThresholdColumn | undefined;
    private _value;
    get value(): DataDatabricksAlertV2EvaluationThresholdValueOutputReference;
    putValue(value: DataDatabricksAlertV2EvaluationThresholdValue): void;
    resetValue(): void;
    get valueInput(): cdktf.IResolvable | DataDatabricksAlertV2EvaluationThresholdValue | undefined;
}
export interface DataDatabricksAlertV2Evaluation {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#comparison_operator DataDatabricksAlertV2#comparison_operator}
    */
    readonly comparisonOperator?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#empty_result_state DataDatabricksAlertV2#empty_result_state}
    */
    readonly emptyResultState?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#notification DataDatabricksAlertV2#notification}
    */
    readonly notification?: DataDatabricksAlertV2EvaluationNotification;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#source DataDatabricksAlertV2#source}
    */
    readonly source?: DataDatabricksAlertV2EvaluationSource;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#threshold DataDatabricksAlertV2#threshold}
    */
    readonly threshold?: DataDatabricksAlertV2EvaluationThreshold;
}
export declare function dataDatabricksAlertV2EvaluationToTerraform(struct?: DataDatabricksAlertV2Evaluation | cdktf.IResolvable): any;
export declare function dataDatabricksAlertV2EvaluationToHclTerraform(struct?: DataDatabricksAlertV2Evaluation | cdktf.IResolvable): any;
export declare class DataDatabricksAlertV2EvaluationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertV2Evaluation | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertV2Evaluation | cdktf.IResolvable | undefined);
    private _comparisonOperator?;
    get comparisonOperator(): string;
    set comparisonOperator(value: string);
    resetComparisonOperator(): void;
    get comparisonOperatorInput(): string | undefined;
    private _emptyResultState?;
    get emptyResultState(): string;
    set emptyResultState(value: string);
    resetEmptyResultState(): void;
    get emptyResultStateInput(): string | undefined;
    get lastEvaluatedAt(): string;
    private _notification;
    get notification(): DataDatabricksAlertV2EvaluationNotificationOutputReference;
    putNotification(value: DataDatabricksAlertV2EvaluationNotification): void;
    resetNotification(): void;
    get notificationInput(): cdktf.IResolvable | DataDatabricksAlertV2EvaluationNotification | undefined;
    private _source;
    get source(): DataDatabricksAlertV2EvaluationSourceOutputReference;
    putSource(value: DataDatabricksAlertV2EvaluationSource): void;
    resetSource(): void;
    get sourceInput(): cdktf.IResolvable | DataDatabricksAlertV2EvaluationSource | undefined;
    get state(): string;
    private _threshold;
    get threshold(): DataDatabricksAlertV2EvaluationThresholdOutputReference;
    putThreshold(value: DataDatabricksAlertV2EvaluationThreshold): void;
    resetThreshold(): void;
    get thresholdInput(): cdktf.IResolvable | DataDatabricksAlertV2EvaluationThreshold | undefined;
}
export interface DataDatabricksAlertV2Schedule {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#pause_status DataDatabricksAlertV2#pause_status}
    */
    readonly pauseStatus?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#quartz_cron_schedule DataDatabricksAlertV2#quartz_cron_schedule}
    */
    readonly quartzCronSchedule?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#timezone_id DataDatabricksAlertV2#timezone_id}
    */
    readonly timezoneId?: string;
}
export declare function dataDatabricksAlertV2ScheduleToTerraform(struct?: DataDatabricksAlertV2Schedule | cdktf.IResolvable): any;
export declare function dataDatabricksAlertV2ScheduleToHclTerraform(struct?: DataDatabricksAlertV2Schedule | cdktf.IResolvable): any;
export declare class DataDatabricksAlertV2ScheduleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertV2Schedule | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertV2Schedule | cdktf.IResolvable | undefined);
    private _pauseStatus?;
    get pauseStatus(): string;
    set pauseStatus(value: string);
    resetPauseStatus(): void;
    get pauseStatusInput(): string | undefined;
    private _quartzCronSchedule?;
    get quartzCronSchedule(): string;
    set quartzCronSchedule(value: string);
    resetQuartzCronSchedule(): void;
    get quartzCronScheduleInput(): string | undefined;
    private _timezoneId?;
    get timezoneId(): string;
    set timezoneId(value: string);
    resetTimezoneId(): void;
    get timezoneIdInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2 databricks_alert_v2}
*/
export declare class DataDatabricksAlertV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "databricks_alert_v2";
    /**
    * Generates CDKTF code for importing a DataDatabricksAlertV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksAlertV2 to import
    * @param importFromId The id of the existing DataDatabricksAlertV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksAlertV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alert_v2 databricks_alert_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksAlertV2Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatabricksAlertV2Config);
    get createTime(): string;
    private _customDescription?;
    get customDescription(): string;
    set customDescription(value: string);
    resetCustomDescription(): void;
    get customDescriptionInput(): string | undefined;
    private _customSummary?;
    get customSummary(): string;
    set customSummary(value: string);
    resetCustomSummary(): void;
    get customSummaryInput(): string | undefined;
    private _displayName?;
    get displayName(): string;
    set displayName(value: string);
    resetDisplayName(): void;
    get displayNameInput(): string | undefined;
    private _evaluation;
    get evaluation(): DataDatabricksAlertV2EvaluationOutputReference;
    putEvaluation(value: DataDatabricksAlertV2Evaluation): void;
    resetEvaluation(): void;
    get evaluationInput(): cdktf.IResolvable | DataDatabricksAlertV2Evaluation | undefined;
    get id(): string;
    get lifecycleState(): string;
    get ownerUserName(): string;
    private _parentPath?;
    get parentPath(): string;
    set parentPath(value: string);
    resetParentPath(): void;
    get parentPathInput(): string | undefined;
    private _queryText?;
    get queryText(): string;
    set queryText(value: string);
    resetQueryText(): void;
    get queryTextInput(): string | undefined;
    private _runAsUserName?;
    get runAsUserName(): string;
    set runAsUserName(value: string);
    resetRunAsUserName(): void;
    get runAsUserNameInput(): string | undefined;
    private _schedule;
    get schedule(): DataDatabricksAlertV2ScheduleOutputReference;
    putSchedule(value: DataDatabricksAlertV2Schedule): void;
    resetSchedule(): void;
    get scheduleInput(): cdktf.IResolvable | DataDatabricksAlertV2Schedule | undefined;
    get updateTime(): string;
    private _warehouseId?;
    get warehouseId(): string;
    set warehouseId(value: string);
    resetWarehouseId(): void;
    get warehouseIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
