/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatabricksAlertsV2Config extends cdktf.TerraformMetaArguments {
}
export interface DataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#destination_id DataDatabricksAlertsV2#destination_id}
    */
    readonly destinationId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#user_email DataDatabricksAlertsV2#user_email}
    */
    readonly userEmail?: string;
}
export declare function dataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptionsToTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptions | cdktf.IResolvable): any;
export declare function dataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptionsToHclTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptions | cdktf.IResolvable): any;
export declare class DataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptions | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptions | cdktf.IResolvable | undefined);
    private _destinationId?;
    get destinationId(): string;
    set destinationId(value: string);
    resetDestinationId(): void;
    get destinationIdInput(): string | undefined;
    private _userEmail?;
    get userEmail(): string;
    set userEmail(value: string);
    resetUserEmail(): void;
    get userEmailInput(): string | undefined;
}
export declare class DataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptionsOutputReference;
}
export interface DataDatabricksAlertsV2ResultsEvaluationNotification {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#notify_on_ok DataDatabricksAlertsV2#notify_on_ok}
    */
    readonly notifyOnOk?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#retrigger_seconds DataDatabricksAlertsV2#retrigger_seconds}
    */
    readonly retriggerSeconds?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#subscriptions DataDatabricksAlertsV2#subscriptions}
    */
    readonly subscriptions?: DataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptions[] | cdktf.IResolvable;
}
export declare function dataDatabricksAlertsV2ResultsEvaluationNotificationToTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluationNotification | cdktf.IResolvable): any;
export declare function dataDatabricksAlertsV2ResultsEvaluationNotificationToHclTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluationNotification | cdktf.IResolvable): any;
export declare class DataDatabricksAlertsV2ResultsEvaluationNotificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertsV2ResultsEvaluationNotification | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertsV2ResultsEvaluationNotification | cdktf.IResolvable | undefined);
    private _notifyOnOk?;
    get notifyOnOk(): boolean | cdktf.IResolvable;
    set notifyOnOk(value: boolean | cdktf.IResolvable);
    resetNotifyOnOk(): void;
    get notifyOnOkInput(): boolean | cdktf.IResolvable | undefined;
    private _retriggerSeconds?;
    get retriggerSeconds(): number;
    set retriggerSeconds(value: number);
    resetRetriggerSeconds(): void;
    get retriggerSecondsInput(): number | undefined;
    private _subscriptions;
    get subscriptions(): DataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptionsList;
    putSubscriptions(value: DataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptions[] | cdktf.IResolvable): void;
    resetSubscriptions(): void;
    get subscriptionsInput(): cdktf.IResolvable | DataDatabricksAlertsV2ResultsEvaluationNotificationSubscriptions[] | undefined;
}
export interface DataDatabricksAlertsV2ResultsEvaluationSource {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#aggregation DataDatabricksAlertsV2#aggregation}
    */
    readonly aggregation?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#display DataDatabricksAlertsV2#display}
    */
    readonly display?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#name DataDatabricksAlertsV2#name}
    */
    readonly name?: string;
}
export declare function dataDatabricksAlertsV2ResultsEvaluationSourceToTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluationSource | cdktf.IResolvable): any;
export declare function dataDatabricksAlertsV2ResultsEvaluationSourceToHclTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluationSource | cdktf.IResolvable): any;
export declare class DataDatabricksAlertsV2ResultsEvaluationSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertsV2ResultsEvaluationSource | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertsV2ResultsEvaluationSource | cdktf.IResolvable | undefined);
    private _aggregation?;
    get aggregation(): string;
    set aggregation(value: string);
    resetAggregation(): void;
    get aggregationInput(): string | undefined;
    private _display?;
    get display(): string;
    set display(value: string);
    resetDisplay(): void;
    get displayInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataDatabricksAlertsV2ResultsEvaluationThresholdColumn {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#aggregation DataDatabricksAlertsV2#aggregation}
    */
    readonly aggregation?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#display DataDatabricksAlertsV2#display}
    */
    readonly display?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#name DataDatabricksAlertsV2#name}
    */
    readonly name?: string;
}
export declare function dataDatabricksAlertsV2ResultsEvaluationThresholdColumnToTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluationThresholdColumn | cdktf.IResolvable): any;
export declare function dataDatabricksAlertsV2ResultsEvaluationThresholdColumnToHclTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluationThresholdColumn | cdktf.IResolvable): any;
export declare class DataDatabricksAlertsV2ResultsEvaluationThresholdColumnOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertsV2ResultsEvaluationThresholdColumn | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertsV2ResultsEvaluationThresholdColumn | cdktf.IResolvable | undefined);
    private _aggregation?;
    get aggregation(): string;
    set aggregation(value: string);
    resetAggregation(): void;
    get aggregationInput(): string | undefined;
    private _display?;
    get display(): string;
    set display(value: string);
    resetDisplay(): void;
    get displayInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataDatabricksAlertsV2ResultsEvaluationThresholdValue {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#bool_value DataDatabricksAlertsV2#bool_value}
    */
    readonly boolValue?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#double_value DataDatabricksAlertsV2#double_value}
    */
    readonly doubleValue?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#string_value DataDatabricksAlertsV2#string_value}
    */
    readonly stringValue?: string;
}
export declare function dataDatabricksAlertsV2ResultsEvaluationThresholdValueToTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluationThresholdValue | cdktf.IResolvable): any;
export declare function dataDatabricksAlertsV2ResultsEvaluationThresholdValueToHclTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluationThresholdValue | cdktf.IResolvable): any;
export declare class DataDatabricksAlertsV2ResultsEvaluationThresholdValueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertsV2ResultsEvaluationThresholdValue | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertsV2ResultsEvaluationThresholdValue | cdktf.IResolvable | undefined);
    private _boolValue?;
    get boolValue(): boolean | cdktf.IResolvable;
    set boolValue(value: boolean | cdktf.IResolvable);
    resetBoolValue(): void;
    get boolValueInput(): boolean | cdktf.IResolvable | undefined;
    private _doubleValue?;
    get doubleValue(): number;
    set doubleValue(value: number);
    resetDoubleValue(): void;
    get doubleValueInput(): number | undefined;
    private _stringValue?;
    get stringValue(): string;
    set stringValue(value: string);
    resetStringValue(): void;
    get stringValueInput(): string | undefined;
}
export interface DataDatabricksAlertsV2ResultsEvaluationThreshold {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#column DataDatabricksAlertsV2#column}
    */
    readonly column?: DataDatabricksAlertsV2ResultsEvaluationThresholdColumn;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#value DataDatabricksAlertsV2#value}
    */
    readonly value?: DataDatabricksAlertsV2ResultsEvaluationThresholdValue;
}
export declare function dataDatabricksAlertsV2ResultsEvaluationThresholdToTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluationThreshold | cdktf.IResolvable): any;
export declare function dataDatabricksAlertsV2ResultsEvaluationThresholdToHclTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluationThreshold | cdktf.IResolvable): any;
export declare class DataDatabricksAlertsV2ResultsEvaluationThresholdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertsV2ResultsEvaluationThreshold | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertsV2ResultsEvaluationThreshold | cdktf.IResolvable | undefined);
    private _column;
    get column(): DataDatabricksAlertsV2ResultsEvaluationThresholdColumnOutputReference;
    putColumn(value: DataDatabricksAlertsV2ResultsEvaluationThresholdColumn): void;
    resetColumn(): void;
    get columnInput(): cdktf.IResolvable | DataDatabricksAlertsV2ResultsEvaluationThresholdColumn | undefined;
    private _value;
    get value(): DataDatabricksAlertsV2ResultsEvaluationThresholdValueOutputReference;
    putValue(value: DataDatabricksAlertsV2ResultsEvaluationThresholdValue): void;
    resetValue(): void;
    get valueInput(): cdktf.IResolvable | DataDatabricksAlertsV2ResultsEvaluationThresholdValue | undefined;
}
export interface DataDatabricksAlertsV2ResultsEvaluation {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#comparison_operator DataDatabricksAlertsV2#comparison_operator}
    */
    readonly comparisonOperator?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#empty_result_state DataDatabricksAlertsV2#empty_result_state}
    */
    readonly emptyResultState?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#notification DataDatabricksAlertsV2#notification}
    */
    readonly notification?: DataDatabricksAlertsV2ResultsEvaluationNotification;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#source DataDatabricksAlertsV2#source}
    */
    readonly source?: DataDatabricksAlertsV2ResultsEvaluationSource;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#threshold DataDatabricksAlertsV2#threshold}
    */
    readonly threshold?: DataDatabricksAlertsV2ResultsEvaluationThreshold;
}
export declare function dataDatabricksAlertsV2ResultsEvaluationToTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluation | cdktf.IResolvable): any;
export declare function dataDatabricksAlertsV2ResultsEvaluationToHclTerraform(struct?: DataDatabricksAlertsV2ResultsEvaluation | cdktf.IResolvable): any;
export declare class DataDatabricksAlertsV2ResultsEvaluationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertsV2ResultsEvaluation | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertsV2ResultsEvaluation | cdktf.IResolvable | undefined);
    private _comparisonOperator?;
    get comparisonOperator(): string;
    set comparisonOperator(value: string);
    resetComparisonOperator(): void;
    get comparisonOperatorInput(): string | undefined;
    private _emptyResultState?;
    get emptyResultState(): string;
    set emptyResultState(value: string);
    resetEmptyResultState(): void;
    get emptyResultStateInput(): string | undefined;
    get lastEvaluatedAt(): string;
    private _notification;
    get notification(): DataDatabricksAlertsV2ResultsEvaluationNotificationOutputReference;
    putNotification(value: DataDatabricksAlertsV2ResultsEvaluationNotification): void;
    resetNotification(): void;
    get notificationInput(): cdktf.IResolvable | DataDatabricksAlertsV2ResultsEvaluationNotification | undefined;
    private _source;
    get source(): DataDatabricksAlertsV2ResultsEvaluationSourceOutputReference;
    putSource(value: DataDatabricksAlertsV2ResultsEvaluationSource): void;
    resetSource(): void;
    get sourceInput(): cdktf.IResolvable | DataDatabricksAlertsV2ResultsEvaluationSource | undefined;
    get state(): string;
    private _threshold;
    get threshold(): DataDatabricksAlertsV2ResultsEvaluationThresholdOutputReference;
    putThreshold(value: DataDatabricksAlertsV2ResultsEvaluationThreshold): void;
    resetThreshold(): void;
    get thresholdInput(): cdktf.IResolvable | DataDatabricksAlertsV2ResultsEvaluationThreshold | undefined;
}
export interface DataDatabricksAlertsV2ResultsSchedule {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#pause_status DataDatabricksAlertsV2#pause_status}
    */
    readonly pauseStatus?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#quartz_cron_schedule DataDatabricksAlertsV2#quartz_cron_schedule}
    */
    readonly quartzCronSchedule?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#timezone_id DataDatabricksAlertsV2#timezone_id}
    */
    readonly timezoneId?: string;
}
export declare function dataDatabricksAlertsV2ResultsScheduleToTerraform(struct?: DataDatabricksAlertsV2ResultsSchedule | cdktf.IResolvable): any;
export declare function dataDatabricksAlertsV2ResultsScheduleToHclTerraform(struct?: DataDatabricksAlertsV2ResultsSchedule | cdktf.IResolvable): any;
export declare class DataDatabricksAlertsV2ResultsScheduleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksAlertsV2ResultsSchedule | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksAlertsV2ResultsSchedule | cdktf.IResolvable | undefined);
    private _pauseStatus?;
    get pauseStatus(): string;
    set pauseStatus(value: string);
    resetPauseStatus(): void;
    get pauseStatusInput(): string | undefined;
    private _quartzCronSchedule?;
    get quartzCronSchedule(): string;
    set quartzCronSchedule(value: string);
    resetQuartzCronSchedule(): void;
    get quartzCronScheduleInput(): string | undefined;
    private _timezoneId?;
    get timezoneId(): string;
    set timezoneId(value: string);
    resetTimezoneId(): void;
    get timezoneIdInput(): string | undefined;
}
export interface DataDatabricksAlertsV2Results {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#custom_description DataDatabricksAlertsV2#custom_description}
    */
    readonly customDescription?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#custom_summary DataDatabricksAlertsV2#custom_summary}
    */
    readonly customSummary?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#display_name DataDatabricksAlertsV2#display_name}
    */
    readonly displayName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#evaluation DataDatabricksAlertsV2#evaluation}
    */
    readonly evaluation?: DataDatabricksAlertsV2ResultsEvaluation;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#parent_path DataDatabricksAlertsV2#parent_path}
    */
    readonly parentPath?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#query_text DataDatabricksAlertsV2#query_text}
    */
    readonly queryText?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#run_as_user_name DataDatabricksAlertsV2#run_as_user_name}
    */
    readonly runAsUserName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#schedule DataDatabricksAlertsV2#schedule}
    */
    readonly schedule?: DataDatabricksAlertsV2ResultsSchedule;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#warehouse_id DataDatabricksAlertsV2#warehouse_id}
    */
    readonly warehouseId?: string;
}
export declare function dataDatabricksAlertsV2ResultsToTerraform(struct?: DataDatabricksAlertsV2Results): any;
export declare function dataDatabricksAlertsV2ResultsToHclTerraform(struct?: DataDatabricksAlertsV2Results): any;
export declare class DataDatabricksAlertsV2ResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksAlertsV2Results | undefined;
    set internalValue(value: DataDatabricksAlertsV2Results | undefined);
    get createTime(): string;
    private _customDescription?;
    get customDescription(): string;
    set customDescription(value: string);
    resetCustomDescription(): void;
    get customDescriptionInput(): string | undefined;
    private _customSummary?;
    get customSummary(): string;
    set customSummary(value: string);
    resetCustomSummary(): void;
    get customSummaryInput(): string | undefined;
    private _displayName?;
    get displayName(): string;
    set displayName(value: string);
    resetDisplayName(): void;
    get displayNameInput(): string | undefined;
    private _evaluation;
    get evaluation(): DataDatabricksAlertsV2ResultsEvaluationOutputReference;
    putEvaluation(value: DataDatabricksAlertsV2ResultsEvaluation): void;
    resetEvaluation(): void;
    get evaluationInput(): cdktf.IResolvable | DataDatabricksAlertsV2ResultsEvaluation | undefined;
    get id(): string;
    get lifecycleState(): string;
    get ownerUserName(): string;
    private _parentPath?;
    get parentPath(): string;
    set parentPath(value: string);
    resetParentPath(): void;
    get parentPathInput(): string | undefined;
    private _queryText?;
    get queryText(): string;
    set queryText(value: string);
    resetQueryText(): void;
    get queryTextInput(): string | undefined;
    private _runAsUserName?;
    get runAsUserName(): string;
    set runAsUserName(value: string);
    resetRunAsUserName(): void;
    get runAsUserNameInput(): string | undefined;
    private _schedule;
    get schedule(): DataDatabricksAlertsV2ResultsScheduleOutputReference;
    putSchedule(value: DataDatabricksAlertsV2ResultsSchedule): void;
    resetSchedule(): void;
    get scheduleInput(): cdktf.IResolvable | DataDatabricksAlertsV2ResultsSchedule | undefined;
    get updateTime(): string;
    private _warehouseId?;
    get warehouseId(): string;
    set warehouseId(value: string);
    resetWarehouseId(): void;
    get warehouseIdInput(): string | undefined;
}
export declare class DataDatabricksAlertsV2ResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksAlertsV2Results[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksAlertsV2ResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2 databricks_alerts_v2}
*/
export declare class DataDatabricksAlertsV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "databricks_alerts_v2";
    /**
    * Generates CDKTF code for importing a DataDatabricksAlertsV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksAlertsV2 to import
    * @param importFromId The id of the existing DataDatabricksAlertsV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksAlertsV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/alerts_v2 databricks_alerts_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksAlertsV2Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatabricksAlertsV2Config);
    private _results;
    get results(): DataDatabricksAlertsV2ResultsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
