/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatabricksDatabaseInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#capacity DataDatabricksDatabaseInstance#capacity}
    */
    readonly capacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#enable_readable_secondaries DataDatabricksDatabaseInstance#enable_readable_secondaries}
    */
    readonly enableReadableSecondaries?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#name DataDatabricksDatabaseInstance#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#node_count DataDatabricksDatabaseInstance#node_count}
    */
    readonly nodeCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#parent_instance_ref DataDatabricksDatabaseInstance#parent_instance_ref}
    */
    readonly parentInstanceRef?: DataDatabricksDatabaseInstanceParentInstanceRef;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#retention_window_in_days DataDatabricksDatabaseInstance#retention_window_in_days}
    */
    readonly retentionWindowInDays?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#stopped DataDatabricksDatabaseInstance#stopped}
    */
    readonly stopped?: boolean | cdktf.IResolvable;
}
export interface DataDatabricksDatabaseInstanceChildInstanceRefs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#branch_time DataDatabricksDatabaseInstance#branch_time}
    */
    readonly branchTime?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#lsn DataDatabricksDatabaseInstance#lsn}
    */
    readonly lsn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#name DataDatabricksDatabaseInstance#name}
    */
    readonly name?: string;
}
export declare function dataDatabricksDatabaseInstanceChildInstanceRefsToTerraform(struct?: DataDatabricksDatabaseInstanceChildInstanceRefs): any;
export declare function dataDatabricksDatabaseInstanceChildInstanceRefsToHclTerraform(struct?: DataDatabricksDatabaseInstanceChildInstanceRefs): any;
export declare class DataDatabricksDatabaseInstanceChildInstanceRefsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksDatabaseInstanceChildInstanceRefs | undefined;
    set internalValue(value: DataDatabricksDatabaseInstanceChildInstanceRefs | undefined);
    private _branchTime?;
    get branchTime(): string;
    set branchTime(value: string);
    resetBranchTime(): void;
    get branchTimeInput(): string | undefined;
    get effectiveLsn(): string;
    private _lsn?;
    get lsn(): string;
    set lsn(value: string);
    resetLsn(): void;
    get lsnInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get uid(): string;
}
export declare class DataDatabricksDatabaseInstanceChildInstanceRefsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksDatabaseInstanceChildInstanceRefs[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksDatabaseInstanceChildInstanceRefsOutputReference;
}
export interface DataDatabricksDatabaseInstanceParentInstanceRef {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#branch_time DataDatabricksDatabaseInstance#branch_time}
    */
    readonly branchTime?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#lsn DataDatabricksDatabaseInstance#lsn}
    */
    readonly lsn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#name DataDatabricksDatabaseInstance#name}
    */
    readonly name?: string;
}
export declare function dataDatabricksDatabaseInstanceParentInstanceRefToTerraform(struct?: DataDatabricksDatabaseInstanceParentInstanceRef | cdktf.IResolvable): any;
export declare function dataDatabricksDatabaseInstanceParentInstanceRefToHclTerraform(struct?: DataDatabricksDatabaseInstanceParentInstanceRef | cdktf.IResolvable): any;
export declare class DataDatabricksDatabaseInstanceParentInstanceRefOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksDatabaseInstanceParentInstanceRef | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksDatabaseInstanceParentInstanceRef | cdktf.IResolvable | undefined);
    private _branchTime?;
    get branchTime(): string;
    set branchTime(value: string);
    resetBranchTime(): void;
    get branchTimeInput(): string | undefined;
    get effectiveLsn(): string;
    private _lsn?;
    get lsn(): string;
    set lsn(value: string);
    resetLsn(): void;
    get lsnInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get uid(): string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance databricks_database_instance}
*/
export declare class DataDatabricksDatabaseInstance extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "databricks_database_instance";
    /**
    * Generates CDKTF code for importing a DataDatabricksDatabaseInstance resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksDatabaseInstance to import
    * @param importFromId The id of the existing DataDatabricksDatabaseInstance that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksDatabaseInstance to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/database_instance databricks_database_instance} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksDatabaseInstanceConfig
    */
    constructor(scope: Construct, id: string, config: DataDatabricksDatabaseInstanceConfig);
    private _capacity?;
    get capacity(): string;
    set capacity(value: string);
    resetCapacity(): void;
    get capacityInput(): string | undefined;
    private _childInstanceRefs;
    get childInstanceRefs(): DataDatabricksDatabaseInstanceChildInstanceRefsList;
    get creationTime(): string;
    get creator(): string;
    get effectiveEnableReadableSecondaries(): cdktf.IResolvable;
    get effectiveNodeCount(): number;
    get effectiveRetentionWindowInDays(): number;
    get effectiveStopped(): cdktf.IResolvable;
    private _enableReadableSecondaries?;
    get enableReadableSecondaries(): boolean | cdktf.IResolvable;
    set enableReadableSecondaries(value: boolean | cdktf.IResolvable);
    resetEnableReadableSecondaries(): void;
    get enableReadableSecondariesInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _nodeCount?;
    get nodeCount(): number;
    set nodeCount(value: number);
    resetNodeCount(): void;
    get nodeCountInput(): number | undefined;
    private _parentInstanceRef;
    get parentInstanceRef(): DataDatabricksDatabaseInstanceParentInstanceRefOutputReference;
    putParentInstanceRef(value: DataDatabricksDatabaseInstanceParentInstanceRef): void;
    resetParentInstanceRef(): void;
    get parentInstanceRefInput(): cdktf.IResolvable | DataDatabricksDatabaseInstanceParentInstanceRef | undefined;
    get pgVersion(): string;
    get readOnlyDns(): string;
    get readWriteDns(): string;
    private _retentionWindowInDays?;
    get retentionWindowInDays(): number;
    set retentionWindowInDays(value: number);
    resetRetentionWindowInDays(): void;
    get retentionWindowInDaysInput(): number | undefined;
    get state(): string;
    private _stopped?;
    get stopped(): boolean | cdktf.IResolvable;
    set stopped(value: boolean | cdktf.IResolvable);
    resetStopped(): void;
    get stoppedInput(): boolean | cdktf.IResolvable | undefined;
    get uid(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
