/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatabricksMaterializedFeaturesFeatureTagsConfig extends cdktf.TerraformMetaArguments {
}
export interface DataDatabricksMaterializedFeaturesFeatureTagsFeatureTags {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/materialized_features_feature_tags#key DataDatabricksMaterializedFeaturesFeatureTags#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/materialized_features_feature_tags#value DataDatabricksMaterializedFeaturesFeatureTags#value}
    */
    readonly value?: string;
}
export declare function dataDatabricksMaterializedFeaturesFeatureTagsFeatureTagsToTerraform(struct?: DataDatabricksMaterializedFeaturesFeatureTagsFeatureTags): any;
export declare function dataDatabricksMaterializedFeaturesFeatureTagsFeatureTagsToHclTerraform(struct?: DataDatabricksMaterializedFeaturesFeatureTagsFeatureTags): any;
export declare class DataDatabricksMaterializedFeaturesFeatureTagsFeatureTagsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksMaterializedFeaturesFeatureTagsFeatureTags | undefined;
    set internalValue(value: DataDatabricksMaterializedFeaturesFeatureTagsFeatureTags | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class DataDatabricksMaterializedFeaturesFeatureTagsFeatureTagsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksMaterializedFeaturesFeatureTagsFeatureTags[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksMaterializedFeaturesFeatureTagsFeatureTagsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/materialized_features_feature_tags databricks_materialized_features_feature_tags}
*/
export declare class DataDatabricksMaterializedFeaturesFeatureTags extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "databricks_materialized_features_feature_tags";
    /**
    * Generates CDKTF code for importing a DataDatabricksMaterializedFeaturesFeatureTags resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksMaterializedFeaturesFeatureTags to import
    * @param importFromId The id of the existing DataDatabricksMaterializedFeaturesFeatureTags that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/materialized_features_feature_tags#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksMaterializedFeaturesFeatureTags to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/materialized_features_feature_tags databricks_materialized_features_feature_tags} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksMaterializedFeaturesFeatureTagsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatabricksMaterializedFeaturesFeatureTagsConfig);
    private _featureTags;
    get featureTags(): DataDatabricksMaterializedFeaturesFeatureTagsFeatureTagsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
