/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatabricksQualityMonitorV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/quality_monitor_v2#object_id DataDatabricksQualityMonitorV2#object_id}
    */
    readonly objectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/quality_monitor_v2#object_type DataDatabricksQualityMonitorV2#object_type}
    */
    readonly objectType: string;
}
export interface DataDatabricksQualityMonitorV2AnomalyDetectionConfig {
}
export declare function dataDatabricksQualityMonitorV2AnomalyDetectionConfigToTerraform(struct?: DataDatabricksQualityMonitorV2AnomalyDetectionConfig): any;
export declare function dataDatabricksQualityMonitorV2AnomalyDetectionConfigToHclTerraform(struct?: DataDatabricksQualityMonitorV2AnomalyDetectionConfig): any;
export declare class DataDatabricksQualityMonitorV2AnomalyDetectionConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksQualityMonitorV2AnomalyDetectionConfig | undefined;
    set internalValue(value: DataDatabricksQualityMonitorV2AnomalyDetectionConfig | undefined);
    get lastRunId(): string;
    get latestRunStatus(): string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/quality_monitor_v2 databricks_quality_monitor_v2}
*/
export declare class DataDatabricksQualityMonitorV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "databricks_quality_monitor_v2";
    /**
    * Generates CDKTF code for importing a DataDatabricksQualityMonitorV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksQualityMonitorV2 to import
    * @param importFromId The id of the existing DataDatabricksQualityMonitorV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/quality_monitor_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksQualityMonitorV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/quality_monitor_v2 databricks_quality_monitor_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksQualityMonitorV2Config
    */
    constructor(scope: Construct, id: string, config: DataDatabricksQualityMonitorV2Config);
    private _anomalyDetectionConfig;
    get anomalyDetectionConfig(): DataDatabricksQualityMonitorV2AnomalyDetectionConfigOutputReference;
    private _objectId?;
    get objectId(): string;
    set objectId(value: string);
    get objectIdInput(): string | undefined;
    private _objectType?;
    get objectType(): string;
    set objectType(value: string);
    get objectTypeInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
