/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface MaterializedFeaturesFeatureTagConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/resources/materialized_features_feature_tag#key MaterializedFeaturesFeatureTag#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/resources/materialized_features_feature_tag#value MaterializedFeaturesFeatureTag#value}
    */
    readonly value?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/resources/materialized_features_feature_tag databricks_materialized_features_feature_tag}
*/
export declare class MaterializedFeaturesFeatureTag extends cdktf.TerraformResource {
    static readonly tfResourceType = "databricks_materialized_features_feature_tag";
    /**
    * Generates CDKTF code for importing a MaterializedFeaturesFeatureTag resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the MaterializedFeaturesFeatureTag to import
    * @param importFromId The id of the existing MaterializedFeaturesFeatureTag that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/resources/materialized_features_feature_tag#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the MaterializedFeaturesFeatureTag to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/resources/materialized_features_feature_tag databricks_materialized_features_feature_tag} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options MaterializedFeaturesFeatureTagConfig
    */
    constructor(scope: Construct, id: string, config: MaterializedFeaturesFeatureTagConfig);
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
