/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OnlineStoreConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/resources/online_store#capacity OnlineStore#capacity}
    */
    readonly capacity: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/resources/online_store#name OnlineStore#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/resources/online_store#read_replica_count OnlineStore#read_replica_count}
    */
    readonly readReplicaCount?: number;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/resources/online_store databricks_online_store}
*/
export declare class OnlineStore extends cdktf.TerraformResource {
    static readonly tfResourceType = "databricks_online_store";
    /**
    * Generates CDKTF code for importing a OnlineStore resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the OnlineStore to import
    * @param importFromId The id of the existing OnlineStore that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/resources/online_store#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the OnlineStore to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/resources/online_store databricks_online_store} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OnlineStoreConfig
    */
    constructor(scope: Construct, id: string, config: OnlineStoreConfig);
    private _capacity?;
    get capacity(): string;
    set capacity(value: string);
    get capacityInput(): string | undefined;
    get creationTime(): string;
    get creator(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _readReplicaCount?;
    get readReplicaCount(): number;
    set readReplicaCount(value: number);
    resetReadReplicaCount(): void;
    get readReplicaCountInput(): number | undefined;
    get state(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
