/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatabricksClusterPluginframeworkConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#cluster_id DataDatabricksClusterPluginframework#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#cluster_info DataDatabricksClusterPluginframework#cluster_info}
    */
    readonly clusterInfo?: DataDatabricksClusterPluginframeworkClusterInfo[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#cluster_name DataDatabricksClusterPluginframework#cluster_name}
    */
    readonly clusterName?: string;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoAutoscale {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#max_workers DataDatabricksClusterPluginframework#max_workers}
    */
    readonly maxWorkers?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#min_workers DataDatabricksClusterPluginframework#min_workers}
    */
    readonly minWorkers?: number;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoAutoscaleToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoAutoscale | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoAutoscaleToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoAutoscale | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoAutoscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoAutoscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoAutoscale | cdktf.IResolvable | undefined);
    private _maxWorkers?;
    get maxWorkers(): number;
    set maxWorkers(value: number);
    resetMaxWorkers(): void;
    get maxWorkersInput(): number | undefined;
    private _minWorkers?;
    get minWorkers(): number;
    set minWorkers(value: number);
    resetMinWorkers(): void;
    get minWorkersInput(): number | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoAutoscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoAutoscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoAutoscaleOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoAwsAttributes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#availability DataDatabricksClusterPluginframework#availability}
    */
    readonly availability?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#ebs_volume_count DataDatabricksClusterPluginframework#ebs_volume_count}
    */
    readonly ebsVolumeCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#ebs_volume_iops DataDatabricksClusterPluginframework#ebs_volume_iops}
    */
    readonly ebsVolumeIops?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#ebs_volume_size DataDatabricksClusterPluginframework#ebs_volume_size}
    */
    readonly ebsVolumeSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#ebs_volume_throughput DataDatabricksClusterPluginframework#ebs_volume_throughput}
    */
    readonly ebsVolumeThroughput?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#ebs_volume_type DataDatabricksClusterPluginframework#ebs_volume_type}
    */
    readonly ebsVolumeType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#first_on_demand DataDatabricksClusterPluginframework#first_on_demand}
    */
    readonly firstOnDemand?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#instance_profile_arn DataDatabricksClusterPluginframework#instance_profile_arn}
    */
    readonly instanceProfileArn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#spot_bid_price_percent DataDatabricksClusterPluginframework#spot_bid_price_percent}
    */
    readonly spotBidPricePercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#zone_id DataDatabricksClusterPluginframework#zone_id}
    */
    readonly zoneId?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoAwsAttributesToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoAwsAttributes | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoAwsAttributesToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoAwsAttributes | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoAwsAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoAwsAttributes | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoAwsAttributes | cdktf.IResolvable | undefined);
    private _availability?;
    get availability(): string;
    set availability(value: string);
    resetAvailability(): void;
    get availabilityInput(): string | undefined;
    private _ebsVolumeCount?;
    get ebsVolumeCount(): number;
    set ebsVolumeCount(value: number);
    resetEbsVolumeCount(): void;
    get ebsVolumeCountInput(): number | undefined;
    private _ebsVolumeIops?;
    get ebsVolumeIops(): number;
    set ebsVolumeIops(value: number);
    resetEbsVolumeIops(): void;
    get ebsVolumeIopsInput(): number | undefined;
    private _ebsVolumeSize?;
    get ebsVolumeSize(): number;
    set ebsVolumeSize(value: number);
    resetEbsVolumeSize(): void;
    get ebsVolumeSizeInput(): number | undefined;
    private _ebsVolumeThroughput?;
    get ebsVolumeThroughput(): number;
    set ebsVolumeThroughput(value: number);
    resetEbsVolumeThroughput(): void;
    get ebsVolumeThroughputInput(): number | undefined;
    private _ebsVolumeType?;
    get ebsVolumeType(): string;
    set ebsVolumeType(value: string);
    resetEbsVolumeType(): void;
    get ebsVolumeTypeInput(): string | undefined;
    private _firstOnDemand?;
    get firstOnDemand(): number;
    set firstOnDemand(value: number);
    resetFirstOnDemand(): void;
    get firstOnDemandInput(): number | undefined;
    private _instanceProfileArn?;
    get instanceProfileArn(): string;
    set instanceProfileArn(value: string);
    resetInstanceProfileArn(): void;
    get instanceProfileArnInput(): string | undefined;
    private _spotBidPricePercent?;
    get spotBidPricePercent(): number;
    set spotBidPricePercent(value: number);
    resetSpotBidPricePercent(): void;
    get spotBidPricePercentInput(): number | undefined;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    resetZoneId(): void;
    get zoneIdInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoAwsAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoAwsAttributes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoAwsAttributesOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfo {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#log_analytics_primary_key DataDatabricksClusterPluginframework#log_analytics_primary_key}
    */
    readonly logAnalyticsPrimaryKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#log_analytics_workspace_id DataDatabricksClusterPluginframework#log_analytics_workspace_id}
    */
    readonly logAnalyticsWorkspaceId?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfoToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfo | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfoToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfo | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfo | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfo | cdktf.IResolvable | undefined);
    private _logAnalyticsPrimaryKey?;
    get logAnalyticsPrimaryKey(): string;
    set logAnalyticsPrimaryKey(value: string);
    resetLogAnalyticsPrimaryKey(): void;
    get logAnalyticsPrimaryKeyInput(): string | undefined;
    private _logAnalyticsWorkspaceId?;
    get logAnalyticsWorkspaceId(): string;
    set logAnalyticsWorkspaceId(value: string);
    resetLogAnalyticsWorkspaceId(): void;
    get logAnalyticsWorkspaceIdInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfoList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfo[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfoOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoAzureAttributes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#availability DataDatabricksClusterPluginframework#availability}
    */
    readonly availability?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#first_on_demand DataDatabricksClusterPluginframework#first_on_demand}
    */
    readonly firstOnDemand?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#log_analytics_info DataDatabricksClusterPluginframework#log_analytics_info}
    */
    readonly logAnalyticsInfo?: DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfo[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#spot_bid_max_price DataDatabricksClusterPluginframework#spot_bid_max_price}
    */
    readonly spotBidMaxPrice?: number;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoAzureAttributesToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoAzureAttributes | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoAzureAttributesToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoAzureAttributes | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoAzureAttributes | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoAzureAttributes | cdktf.IResolvable | undefined);
    private _availability?;
    get availability(): string;
    set availability(value: string);
    resetAvailability(): void;
    get availabilityInput(): string | undefined;
    private _firstOnDemand?;
    get firstOnDemand(): number;
    set firstOnDemand(value: number);
    resetFirstOnDemand(): void;
    get firstOnDemandInput(): number | undefined;
    private _logAnalyticsInfo;
    get logAnalyticsInfo(): DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfoList;
    putLogAnalyticsInfo(value: DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfo[] | cdktf.IResolvable): void;
    resetLogAnalyticsInfo(): void;
    get logAnalyticsInfoInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesLogAnalyticsInfo[] | undefined;
    private _spotBidMaxPrice?;
    get spotBidMaxPrice(): number;
    set spotBidMaxPrice(value: number);
    resetSpotBidMaxPrice(): void;
    get spotBidMaxPriceInput(): number | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoAzureAttributes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfsToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfs | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfsToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfs | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfs | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfs | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfs[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfsOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3 {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#canned_acl DataDatabricksClusterPluginframework#canned_acl}
    */
    readonly cannedAcl?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#enable_encryption DataDatabricksClusterPluginframework#enable_encryption}
    */
    readonly enableEncryption?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#encryption_type DataDatabricksClusterPluginframework#encryption_type}
    */
    readonly encryptionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#endpoint DataDatabricksClusterPluginframework#endpoint}
    */
    readonly endpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#kms_key DataDatabricksClusterPluginframework#kms_key}
    */
    readonly kmsKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#region DataDatabricksClusterPluginframework#region}
    */
    readonly region?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3ToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3 | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3ToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3 | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3 | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3 | cdktf.IResolvable | undefined);
    private _cannedAcl?;
    get cannedAcl(): string;
    set cannedAcl(value: string);
    resetCannedAcl(): void;
    get cannedAclInput(): string | undefined;
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
    private _enableEncryption?;
    get enableEncryption(): boolean | cdktf.IResolvable;
    set enableEncryption(value: boolean | cdktf.IResolvable);
    resetEnableEncryption(): void;
    get enableEncryptionInput(): boolean | cdktf.IResolvable | undefined;
    private _encryptionType?;
    get encryptionType(): string;
    set encryptionType(value: string);
    resetEncryptionType(): void;
    get encryptionTypeInput(): string | undefined;
    private _endpoint?;
    get endpoint(): string;
    set endpoint(value: string);
    resetEndpoint(): void;
    get endpointInput(): string | undefined;
    private _kmsKey?;
    get kmsKey(): string;
    set kmsKey(value: string);
    resetKmsKey(): void;
    get kmsKeyInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3List extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3OutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumesToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumes | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumesToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumes | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumes | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumes | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumesOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoClusterLogConf {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#dbfs DataDatabricksClusterPluginframework#dbfs}
    */
    readonly dbfs?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfs[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#s3 DataDatabricksClusterPluginframework#s3}
    */
    readonly s3?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#volumes DataDatabricksClusterPluginframework#volumes}
    */
    readonly volumes?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumes[] | cdktf.IResolvable;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoClusterLogConfToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConf | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoClusterLogConfToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConf | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoClusterLogConf | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConf | cdktf.IResolvable | undefined);
    private _dbfs;
    get dbfs(): DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfsList;
    putDbfs(value: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfs[] | cdktf.IResolvable): void;
    resetDbfs(): void;
    get dbfsInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfDbfs[] | undefined;
    private _s3;
    get s3(): DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3List;
    putS3(value: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3[] | cdktf.IResolvable): void;
    resetS3(): void;
    get s3Input(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfS3[] | undefined;
    private _volumes;
    get volumes(): DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumesList;
    putVolumes(value: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumes[] | cdktf.IResolvable): void;
    resetVolumes(): void;
    get volumesInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfVolumes[] | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConf[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoClusterLogStatus {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#last_attempted DataDatabricksClusterPluginframework#last_attempted}
    */
    readonly lastAttempted?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#last_exception DataDatabricksClusterPluginframework#last_exception}
    */
    readonly lastException?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoClusterLogStatusToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogStatus | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoClusterLogStatusToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogStatus | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoClusterLogStatusOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoClusterLogStatus | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoClusterLogStatus | cdktf.IResolvable | undefined);
    private _lastAttempted?;
    get lastAttempted(): number;
    set lastAttempted(value: number);
    resetLastAttempted(): void;
    get lastAttemptedInput(): number | undefined;
    private _lastException?;
    get lastException(): string;
    set lastException(value: string);
    resetLastException(): void;
    get lastExceptionInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoClusterLogStatusList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogStatus[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoClusterLogStatusOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuth {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#password DataDatabricksClusterPluginframework#password}
    */
    readonly password?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#username DataDatabricksClusterPluginframework#username}
    */
    readonly username?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuthToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuth | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuthToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuth | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuthOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuth | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuth | cdktf.IResolvable | undefined);
    private _password?;
    get password(): string;
    set password(value: string);
    resetPassword(): void;
    get passwordInput(): string | undefined;
    private _username?;
    get username(): string;
    set username(value: string);
    resetUsername(): void;
    get usernameInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuthList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuth[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuthOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoDockerImage {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#basic_auth DataDatabricksClusterPluginframework#basic_auth}
    */
    readonly basicAuth?: DataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuth[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#url DataDatabricksClusterPluginframework#url}
    */
    readonly url?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoDockerImageToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoDockerImage | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoDockerImageToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoDockerImage | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoDockerImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoDockerImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoDockerImage | cdktf.IResolvable | undefined);
    private _basicAuth;
    get basicAuth(): DataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuthList;
    putBasicAuth(value: DataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuth[] | cdktf.IResolvable): void;
    resetBasicAuth(): void;
    get basicAuthInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoDockerImageBasicAuth[] | undefined;
    private _url?;
    get url(): string;
    set url(value: string);
    resetUrl(): void;
    get urlInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoDockerImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoDockerImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoDockerImageOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#is_spot DataDatabricksClusterPluginframework#is_spot}
    */
    readonly isSpot?: boolean | cdktf.IResolvable;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributesToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributes | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributesToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributes | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributes | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributes | cdktf.IResolvable | undefined);
    private _isSpot?;
    get isSpot(): boolean | cdktf.IResolvable;
    set isSpot(value: boolean | cdktf.IResolvable);
    resetIsSpot(): void;
    get isSpotInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributesOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoDriver {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#host_private_ip DataDatabricksClusterPluginframework#host_private_ip}
    */
    readonly hostPrivateIp?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#instance_id DataDatabricksClusterPluginframework#instance_id}
    */
    readonly instanceId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#node_aws_attributes DataDatabricksClusterPluginframework#node_aws_attributes}
    */
    readonly nodeAwsAttributes?: DataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributes[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#node_id DataDatabricksClusterPluginframework#node_id}
    */
    readonly nodeId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#private_ip DataDatabricksClusterPluginframework#private_ip}
    */
    readonly privateIp?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#public_dns DataDatabricksClusterPluginframework#public_dns}
    */
    readonly publicDns?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#start_timestamp DataDatabricksClusterPluginframework#start_timestamp}
    */
    readonly startTimestamp?: number;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoDriverToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoDriver | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoDriverToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoDriver | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoDriverOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoDriver | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoDriver | cdktf.IResolvable | undefined);
    private _hostPrivateIp?;
    get hostPrivateIp(): string;
    set hostPrivateIp(value: string);
    resetHostPrivateIp(): void;
    get hostPrivateIpInput(): string | undefined;
    private _instanceId?;
    get instanceId(): string;
    set instanceId(value: string);
    resetInstanceId(): void;
    get instanceIdInput(): string | undefined;
    private _nodeAwsAttributes;
    get nodeAwsAttributes(): DataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributesList;
    putNodeAwsAttributes(value: DataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributes[] | cdktf.IResolvable): void;
    resetNodeAwsAttributes(): void;
    get nodeAwsAttributesInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoDriverNodeAwsAttributes[] | undefined;
    private _nodeId?;
    get nodeId(): string;
    set nodeId(value: string);
    resetNodeId(): void;
    get nodeIdInput(): string | undefined;
    private _privateIp?;
    get privateIp(): string;
    set privateIp(value: string);
    resetPrivateIp(): void;
    get privateIpInput(): string | undefined;
    private _publicDns?;
    get publicDns(): string;
    set publicDns(value: string);
    resetPublicDns(): void;
    get publicDnsInput(): string | undefined;
    private _startTimestamp?;
    get startTimestamp(): number;
    set startTimestamp(value: number);
    resetStartTimestamp(): void;
    get startTimestampInput(): number | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoDriverList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoDriver[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoDriverOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#is_spot DataDatabricksClusterPluginframework#is_spot}
    */
    readonly isSpot?: boolean | cdktf.IResolvable;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributesToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributes | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributesToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributes | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributes | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributes | cdktf.IResolvable | undefined);
    private _isSpot?;
    get isSpot(): boolean | cdktf.IResolvable;
    set isSpot(value: boolean | cdktf.IResolvable);
    resetIsSpot(): void;
    get isSpotInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributesOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoExecutors {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#host_private_ip DataDatabricksClusterPluginframework#host_private_ip}
    */
    readonly hostPrivateIp?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#instance_id DataDatabricksClusterPluginframework#instance_id}
    */
    readonly instanceId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#node_aws_attributes DataDatabricksClusterPluginframework#node_aws_attributes}
    */
    readonly nodeAwsAttributes?: DataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributes[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#node_id DataDatabricksClusterPluginframework#node_id}
    */
    readonly nodeId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#private_ip DataDatabricksClusterPluginframework#private_ip}
    */
    readonly privateIp?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#public_dns DataDatabricksClusterPluginframework#public_dns}
    */
    readonly publicDns?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#start_timestamp DataDatabricksClusterPluginframework#start_timestamp}
    */
    readonly startTimestamp?: number;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoExecutorsToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoExecutors | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoExecutorsToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoExecutors | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoExecutorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoExecutors | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoExecutors | cdktf.IResolvable | undefined);
    private _hostPrivateIp?;
    get hostPrivateIp(): string;
    set hostPrivateIp(value: string);
    resetHostPrivateIp(): void;
    get hostPrivateIpInput(): string | undefined;
    private _instanceId?;
    get instanceId(): string;
    set instanceId(value: string);
    resetInstanceId(): void;
    get instanceIdInput(): string | undefined;
    private _nodeAwsAttributes;
    get nodeAwsAttributes(): DataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributesList;
    putNodeAwsAttributes(value: DataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributes[] | cdktf.IResolvable): void;
    resetNodeAwsAttributes(): void;
    get nodeAwsAttributesInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoExecutorsNodeAwsAttributes[] | undefined;
    private _nodeId?;
    get nodeId(): string;
    set nodeId(value: string);
    resetNodeId(): void;
    get nodeIdInput(): string | undefined;
    private _privateIp?;
    get privateIp(): string;
    set privateIp(value: string);
    resetPrivateIp(): void;
    get privateIpInput(): string | undefined;
    private _publicDns?;
    get publicDns(): string;
    set publicDns(value: string);
    resetPublicDns(): void;
    get publicDnsInput(): string | undefined;
    private _startTimestamp?;
    get startTimestamp(): number;
    set startTimestamp(value: number);
    resetStartTimestamp(): void;
    get startTimestampInput(): number | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoExecutorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoExecutors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoExecutorsOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoGcpAttributes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#availability DataDatabricksClusterPluginframework#availability}
    */
    readonly availability?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#boot_disk_size DataDatabricksClusterPluginframework#boot_disk_size}
    */
    readonly bootDiskSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#google_service_account DataDatabricksClusterPluginframework#google_service_account}
    */
    readonly googleServiceAccount?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#local_ssd_count DataDatabricksClusterPluginframework#local_ssd_count}
    */
    readonly localSsdCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#use_preemptible_executors DataDatabricksClusterPluginframework#use_preemptible_executors}
    */
    readonly usePreemptibleExecutors?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#zone_id DataDatabricksClusterPluginframework#zone_id}
    */
    readonly zoneId?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoGcpAttributesToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoGcpAttributes | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoGcpAttributesToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoGcpAttributes | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoGcpAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoGcpAttributes | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoGcpAttributes | cdktf.IResolvable | undefined);
    private _availability?;
    get availability(): string;
    set availability(value: string);
    resetAvailability(): void;
    get availabilityInput(): string | undefined;
    private _bootDiskSize?;
    get bootDiskSize(): number;
    set bootDiskSize(value: number);
    resetBootDiskSize(): void;
    get bootDiskSizeInput(): number | undefined;
    private _googleServiceAccount?;
    get googleServiceAccount(): string;
    set googleServiceAccount(value: string);
    resetGoogleServiceAccount(): void;
    get googleServiceAccountInput(): string | undefined;
    private _localSsdCount?;
    get localSsdCount(): number;
    set localSsdCount(value: number);
    resetLocalSsdCount(): void;
    get localSsdCountInput(): number | undefined;
    private _usePreemptibleExecutors?;
    get usePreemptibleExecutors(): boolean | cdktf.IResolvable;
    set usePreemptibleExecutors(value: boolean | cdktf.IResolvable);
    resetUsePreemptibleExecutors(): void;
    get usePreemptibleExecutorsInput(): boolean | cdktf.IResolvable | undefined;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    resetZoneId(): void;
    get zoneIdInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoGcpAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoGcpAttributes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoGcpAttributesOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfss {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfssToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfss | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfssToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfss | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfssOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfss | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfss | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfssList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfss[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfssOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfsToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfs | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfsToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfs | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfs | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfs | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfs[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfsOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoInitScriptsFile {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsFileToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsFile | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsFileToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsFile | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsFileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsFile | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsFile | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsFileList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsFile[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsFileOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcsToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcs | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcsToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcs | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcs | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcs | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcs[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcsOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3 {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#canned_acl DataDatabricksClusterPluginframework#canned_acl}
    */
    readonly cannedAcl?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#enable_encryption DataDatabricksClusterPluginframework#enable_encryption}
    */
    readonly enableEncryption?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#encryption_type DataDatabricksClusterPluginframework#encryption_type}
    */
    readonly encryptionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#endpoint DataDatabricksClusterPluginframework#endpoint}
    */
    readonly endpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#kms_key DataDatabricksClusterPluginframework#kms_key}
    */
    readonly kmsKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#region DataDatabricksClusterPluginframework#region}
    */
    readonly region?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3ToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3 | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3ToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3 | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3 | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3 | cdktf.IResolvable | undefined);
    private _cannedAcl?;
    get cannedAcl(): string;
    set cannedAcl(value: string);
    resetCannedAcl(): void;
    get cannedAclInput(): string | undefined;
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
    private _enableEncryption?;
    get enableEncryption(): boolean | cdktf.IResolvable;
    set enableEncryption(value: boolean | cdktf.IResolvable);
    resetEnableEncryption(): void;
    get enableEncryptionInput(): boolean | cdktf.IResolvable | undefined;
    private _encryptionType?;
    get encryptionType(): string;
    set encryptionType(value: string);
    resetEncryptionType(): void;
    get encryptionTypeInput(): string | undefined;
    private _endpoint?;
    get endpoint(): string;
    set endpoint(value: string);
    resetEndpoint(): void;
    get endpointInput(): string | undefined;
    private _kmsKey?;
    get kmsKey(): string;
    set kmsKey(value: string);
    resetKmsKey(): void;
    get kmsKeyInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3List extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3OutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumesToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumes | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumesToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumes | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumes | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumes | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumesOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspace {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspaceToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspace | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspaceToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspace | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspace | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspace | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspaceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspace[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspaceOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoInitScripts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#abfss DataDatabricksClusterPluginframework#abfss}
    */
    readonly abfss?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfss[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#dbfs DataDatabricksClusterPluginframework#dbfs}
    */
    readonly dbfs?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfs[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#file DataDatabricksClusterPluginframework#file}
    */
    readonly file?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsFile[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#gcs DataDatabricksClusterPluginframework#gcs}
    */
    readonly gcs?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcs[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#s3 DataDatabricksClusterPluginframework#s3}
    */
    readonly s3?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#volumes DataDatabricksClusterPluginframework#volumes}
    */
    readonly volumes?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumes[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#workspace DataDatabricksClusterPluginframework#workspace}
    */
    readonly workspace?: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspace[] | cdktf.IResolvable;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScripts | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoInitScriptsToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoInitScripts | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoInitScripts | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoInitScripts | cdktf.IResolvable | undefined);
    private _abfss;
    get abfss(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfssList;
    putAbfss(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfss[] | cdktf.IResolvable): void;
    resetAbfss(): void;
    get abfssInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoInitScriptsAbfss[] | undefined;
    private _dbfs;
    get dbfs(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfsList;
    putDbfs(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfs[] | cdktf.IResolvable): void;
    resetDbfs(): void;
    get dbfsInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoInitScriptsDbfs[] | undefined;
    private _file;
    get file(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsFileList;
    putFile(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsFile[] | cdktf.IResolvable): void;
    resetFile(): void;
    get fileInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoInitScriptsFile[] | undefined;
    private _gcs;
    get gcs(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcsList;
    putGcs(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcs[] | cdktf.IResolvable): void;
    resetGcs(): void;
    get gcsInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoInitScriptsGcs[] | undefined;
    private _s3;
    get s3(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3List;
    putS3(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3[] | cdktf.IResolvable): void;
    resetS3(): void;
    get s3Input(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoInitScriptsS3[] | undefined;
    private _volumes;
    get volumes(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumesList;
    putVolumes(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumes[] | cdktf.IResolvable): void;
    resetVolumes(): void;
    get volumesInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoInitScriptsVolumes[] | undefined;
    private _workspace;
    get workspace(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspaceList;
    putWorkspace(value: DataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspace[] | cdktf.IResolvable): void;
    resetWorkspace(): void;
    get workspaceInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoInitScriptsWorkspace[] | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoInitScriptsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoInitScripts[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecAutoscale {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#max_workers DataDatabricksClusterPluginframework#max_workers}
    */
    readonly maxWorkers?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#min_workers DataDatabricksClusterPluginframework#min_workers}
    */
    readonly minWorkers?: number;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecAutoscaleToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecAutoscale | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecAutoscaleToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecAutoscale | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecAutoscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecAutoscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecAutoscale | cdktf.IResolvable | undefined);
    private _maxWorkers?;
    get maxWorkers(): number;
    set maxWorkers(value: number);
    resetMaxWorkers(): void;
    get maxWorkersInput(): number | undefined;
    private _minWorkers?;
    get minWorkers(): number;
    set minWorkers(value: number);
    resetMinWorkers(): void;
    get minWorkersInput(): number | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecAutoscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecAutoscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecAutoscaleOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#availability DataDatabricksClusterPluginframework#availability}
    */
    readonly availability?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#ebs_volume_count DataDatabricksClusterPluginframework#ebs_volume_count}
    */
    readonly ebsVolumeCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#ebs_volume_iops DataDatabricksClusterPluginframework#ebs_volume_iops}
    */
    readonly ebsVolumeIops?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#ebs_volume_size DataDatabricksClusterPluginframework#ebs_volume_size}
    */
    readonly ebsVolumeSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#ebs_volume_throughput DataDatabricksClusterPluginframework#ebs_volume_throughput}
    */
    readonly ebsVolumeThroughput?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#ebs_volume_type DataDatabricksClusterPluginframework#ebs_volume_type}
    */
    readonly ebsVolumeType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#first_on_demand DataDatabricksClusterPluginframework#first_on_demand}
    */
    readonly firstOnDemand?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#instance_profile_arn DataDatabricksClusterPluginframework#instance_profile_arn}
    */
    readonly instanceProfileArn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#spot_bid_price_percent DataDatabricksClusterPluginframework#spot_bid_price_percent}
    */
    readonly spotBidPricePercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#zone_id DataDatabricksClusterPluginframework#zone_id}
    */
    readonly zoneId?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributesToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributes | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributesToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributes | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributes | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributes | cdktf.IResolvable | undefined);
    private _availability?;
    get availability(): string;
    set availability(value: string);
    resetAvailability(): void;
    get availabilityInput(): string | undefined;
    private _ebsVolumeCount?;
    get ebsVolumeCount(): number;
    set ebsVolumeCount(value: number);
    resetEbsVolumeCount(): void;
    get ebsVolumeCountInput(): number | undefined;
    private _ebsVolumeIops?;
    get ebsVolumeIops(): number;
    set ebsVolumeIops(value: number);
    resetEbsVolumeIops(): void;
    get ebsVolumeIopsInput(): number | undefined;
    private _ebsVolumeSize?;
    get ebsVolumeSize(): number;
    set ebsVolumeSize(value: number);
    resetEbsVolumeSize(): void;
    get ebsVolumeSizeInput(): number | undefined;
    private _ebsVolumeThroughput?;
    get ebsVolumeThroughput(): number;
    set ebsVolumeThroughput(value: number);
    resetEbsVolumeThroughput(): void;
    get ebsVolumeThroughputInput(): number | undefined;
    private _ebsVolumeType?;
    get ebsVolumeType(): string;
    set ebsVolumeType(value: string);
    resetEbsVolumeType(): void;
    get ebsVolumeTypeInput(): string | undefined;
    private _firstOnDemand?;
    get firstOnDemand(): number;
    set firstOnDemand(value: number);
    resetFirstOnDemand(): void;
    get firstOnDemandInput(): number | undefined;
    private _instanceProfileArn?;
    get instanceProfileArn(): string;
    set instanceProfileArn(value: string);
    resetInstanceProfileArn(): void;
    get instanceProfileArnInput(): string | undefined;
    private _spotBidPricePercent?;
    get spotBidPricePercent(): number;
    set spotBidPricePercent(value: number);
    resetSpotBidPricePercent(): void;
    get spotBidPricePercentInput(): number | undefined;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    resetZoneId(): void;
    get zoneIdInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributesOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfo {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#log_analytics_primary_key DataDatabricksClusterPluginframework#log_analytics_primary_key}
    */
    readonly logAnalyticsPrimaryKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#log_analytics_workspace_id DataDatabricksClusterPluginframework#log_analytics_workspace_id}
    */
    readonly logAnalyticsWorkspaceId?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfoToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfo | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfoToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfo | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfo | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfo | cdktf.IResolvable | undefined);
    private _logAnalyticsPrimaryKey?;
    get logAnalyticsPrimaryKey(): string;
    set logAnalyticsPrimaryKey(value: string);
    resetLogAnalyticsPrimaryKey(): void;
    get logAnalyticsPrimaryKeyInput(): string | undefined;
    private _logAnalyticsWorkspaceId?;
    get logAnalyticsWorkspaceId(): string;
    set logAnalyticsWorkspaceId(value: string);
    resetLogAnalyticsWorkspaceId(): void;
    get logAnalyticsWorkspaceIdInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfoList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfo[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfoOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#availability DataDatabricksClusterPluginframework#availability}
    */
    readonly availability?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#first_on_demand DataDatabricksClusterPluginframework#first_on_demand}
    */
    readonly firstOnDemand?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#log_analytics_info DataDatabricksClusterPluginframework#log_analytics_info}
    */
    readonly logAnalyticsInfo?: DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfo[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#spot_bid_max_price DataDatabricksClusterPluginframework#spot_bid_max_price}
    */
    readonly spotBidMaxPrice?: number;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributes | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributes | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributes | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributes | cdktf.IResolvable | undefined);
    private _availability?;
    get availability(): string;
    set availability(value: string);
    resetAvailability(): void;
    get availabilityInput(): string | undefined;
    private _firstOnDemand?;
    get firstOnDemand(): number;
    set firstOnDemand(value: number);
    resetFirstOnDemand(): void;
    get firstOnDemandInput(): number | undefined;
    private _logAnalyticsInfo;
    get logAnalyticsInfo(): DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfoList;
    putLogAnalyticsInfo(value: DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfo[] | cdktf.IResolvable): void;
    resetLogAnalyticsInfo(): void;
    get logAnalyticsInfoInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesLogAnalyticsInfo[] | undefined;
    private _spotBidMaxPrice?;
    get spotBidMaxPrice(): number;
    set spotBidMaxPrice(value: number);
    resetSpotBidMaxPrice(): void;
    get spotBidMaxPriceInput(): number | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfsToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfs | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfsToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfs | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfs | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfs | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfs[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfsOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3 {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#canned_acl DataDatabricksClusterPluginframework#canned_acl}
    */
    readonly cannedAcl?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#enable_encryption DataDatabricksClusterPluginframework#enable_encryption}
    */
    readonly enableEncryption?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#encryption_type DataDatabricksClusterPluginframework#encryption_type}
    */
    readonly encryptionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#endpoint DataDatabricksClusterPluginframework#endpoint}
    */
    readonly endpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#kms_key DataDatabricksClusterPluginframework#kms_key}
    */
    readonly kmsKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#region DataDatabricksClusterPluginframework#region}
    */
    readonly region?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3ToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3 | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3ToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3 | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3 | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3 | cdktf.IResolvable | undefined);
    private _cannedAcl?;
    get cannedAcl(): string;
    set cannedAcl(value: string);
    resetCannedAcl(): void;
    get cannedAclInput(): string | undefined;
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
    private _enableEncryption?;
    get enableEncryption(): boolean | cdktf.IResolvable;
    set enableEncryption(value: boolean | cdktf.IResolvable);
    resetEnableEncryption(): void;
    get enableEncryptionInput(): boolean | cdktf.IResolvable | undefined;
    private _encryptionType?;
    get encryptionType(): string;
    set encryptionType(value: string);
    resetEncryptionType(): void;
    get encryptionTypeInput(): string | undefined;
    private _endpoint?;
    get endpoint(): string;
    set endpoint(value: string);
    resetEndpoint(): void;
    get endpointInput(): string | undefined;
    private _kmsKey?;
    get kmsKey(): string;
    set kmsKey(value: string);
    resetKmsKey(): void;
    get kmsKeyInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3List extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3OutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumesToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumes | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumesToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumes | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumes | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumes | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumesOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConf {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#dbfs DataDatabricksClusterPluginframework#dbfs}
    */
    readonly dbfs?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfs[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#s3 DataDatabricksClusterPluginframework#s3}
    */
    readonly s3?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#volumes DataDatabricksClusterPluginframework#volumes}
    */
    readonly volumes?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumes[] | cdktf.IResolvable;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConf | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConf | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConf | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConf | cdktf.IResolvable | undefined);
    private _dbfs;
    get dbfs(): DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfsList;
    putDbfs(value: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfs[] | cdktf.IResolvable): void;
    resetDbfs(): void;
    get dbfsInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfDbfs[] | undefined;
    private _s3;
    get s3(): DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3List;
    putS3(value: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3[] | cdktf.IResolvable): void;
    resetS3(): void;
    get s3Input(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfS3[] | undefined;
    private _volumes;
    get volumes(): DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumesList;
    putVolumes(value: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumes[] | cdktf.IResolvable): void;
    resetVolumes(): void;
    get volumesInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfVolumes[] | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConf[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuth {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#password DataDatabricksClusterPluginframework#password}
    */
    readonly password?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#username DataDatabricksClusterPluginframework#username}
    */
    readonly username?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuthToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuth | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuthToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuth | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuthOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuth | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuth | cdktf.IResolvable | undefined);
    private _password?;
    get password(): string;
    set password(value: string);
    resetPassword(): void;
    get passwordInput(): string | undefined;
    private _username?;
    get username(): string;
    set username(value: string);
    resetUsername(): void;
    get usernameInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuthList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuth[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuthOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImage {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#basic_auth DataDatabricksClusterPluginframework#basic_auth}
    */
    readonly basicAuth?: DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuth[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#url DataDatabricksClusterPluginframework#url}
    */
    readonly url?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImage | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImage | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImage | cdktf.IResolvable | undefined);
    private _basicAuth;
    get basicAuth(): DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuthList;
    putBasicAuth(value: DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuth[] | cdktf.IResolvable): void;
    resetBasicAuth(): void;
    get basicAuthInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageBasicAuth[] | undefined;
    private _url?;
    get url(): string;
    set url(value: string);
    resetUrl(): void;
    get urlInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#availability DataDatabricksClusterPluginframework#availability}
    */
    readonly availability?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#boot_disk_size DataDatabricksClusterPluginframework#boot_disk_size}
    */
    readonly bootDiskSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#google_service_account DataDatabricksClusterPluginframework#google_service_account}
    */
    readonly googleServiceAccount?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#local_ssd_count DataDatabricksClusterPluginframework#local_ssd_count}
    */
    readonly localSsdCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#use_preemptible_executors DataDatabricksClusterPluginframework#use_preemptible_executors}
    */
    readonly usePreemptibleExecutors?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#zone_id DataDatabricksClusterPluginframework#zone_id}
    */
    readonly zoneId?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributesToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributes | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributesToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributes | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributes | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributes | cdktf.IResolvable | undefined);
    private _availability?;
    get availability(): string;
    set availability(value: string);
    resetAvailability(): void;
    get availabilityInput(): string | undefined;
    private _bootDiskSize?;
    get bootDiskSize(): number;
    set bootDiskSize(value: number);
    resetBootDiskSize(): void;
    get bootDiskSizeInput(): number | undefined;
    private _googleServiceAccount?;
    get googleServiceAccount(): string;
    set googleServiceAccount(value: string);
    resetGoogleServiceAccount(): void;
    get googleServiceAccountInput(): string | undefined;
    private _localSsdCount?;
    get localSsdCount(): number;
    set localSsdCount(value: number);
    resetLocalSsdCount(): void;
    get localSsdCountInput(): number | undefined;
    private _usePreemptibleExecutors?;
    get usePreemptibleExecutors(): boolean | cdktf.IResolvable;
    set usePreemptibleExecutors(value: boolean | cdktf.IResolvable);
    resetUsePreemptibleExecutors(): void;
    get usePreemptibleExecutorsInput(): boolean | cdktf.IResolvable | undefined;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    resetZoneId(): void;
    get zoneIdInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributesOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfss {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfssToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfss | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfssToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfss | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfssOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfss | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfss | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfssList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfss[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfssOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfsToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfs | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfsToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfs | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfs | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfs | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfs[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfsOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFile {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFileToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFile | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFileToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFile | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFile | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFile | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFileList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFile[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFileOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcsToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcs | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcsToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcs | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcs | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcs | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcs[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcsOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3 {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#canned_acl DataDatabricksClusterPluginframework#canned_acl}
    */
    readonly cannedAcl?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#enable_encryption DataDatabricksClusterPluginframework#enable_encryption}
    */
    readonly enableEncryption?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#encryption_type DataDatabricksClusterPluginframework#encryption_type}
    */
    readonly encryptionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#endpoint DataDatabricksClusterPluginframework#endpoint}
    */
    readonly endpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#kms_key DataDatabricksClusterPluginframework#kms_key}
    */
    readonly kmsKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#region DataDatabricksClusterPluginframework#region}
    */
    readonly region?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3ToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3 | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3ToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3 | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3 | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3 | cdktf.IResolvable | undefined);
    private _cannedAcl?;
    get cannedAcl(): string;
    set cannedAcl(value: string);
    resetCannedAcl(): void;
    get cannedAclInput(): string | undefined;
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
    private _enableEncryption?;
    get enableEncryption(): boolean | cdktf.IResolvable;
    set enableEncryption(value: boolean | cdktf.IResolvable);
    resetEnableEncryption(): void;
    get enableEncryptionInput(): boolean | cdktf.IResolvable | undefined;
    private _encryptionType?;
    get encryptionType(): string;
    set encryptionType(value: string);
    resetEncryptionType(): void;
    get encryptionTypeInput(): string | undefined;
    private _endpoint?;
    get endpoint(): string;
    set endpoint(value: string);
    resetEndpoint(): void;
    get endpointInput(): string | undefined;
    private _kmsKey?;
    get kmsKey(): string;
    set kmsKey(value: string);
    resetKmsKey(): void;
    get kmsKeyInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3List extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3OutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumesToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumes | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumesToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumes | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumes | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumes | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumesOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspace {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#destination DataDatabricksClusterPluginframework#destination}
    */
    readonly destination: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspaceToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspace | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspaceToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspace | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspace | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspace | cdktf.IResolvable | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspaceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspace[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspaceOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecInitScripts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#abfss DataDatabricksClusterPluginframework#abfss}
    */
    readonly abfss?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfss[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#dbfs DataDatabricksClusterPluginframework#dbfs}
    */
    readonly dbfs?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfs[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#file DataDatabricksClusterPluginframework#file}
    */
    readonly file?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFile[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#gcs DataDatabricksClusterPluginframework#gcs}
    */
    readonly gcs?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcs[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#s3 DataDatabricksClusterPluginframework#s3}
    */
    readonly s3?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#volumes DataDatabricksClusterPluginframework#volumes}
    */
    readonly volumes?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumes[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#workspace DataDatabricksClusterPluginframework#workspace}
    */
    readonly workspace?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspace[] | cdktf.IResolvable;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScripts | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScripts | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScripts | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScripts | cdktf.IResolvable | undefined);
    private _abfss;
    get abfss(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfssList;
    putAbfss(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfss[] | cdktf.IResolvable): void;
    resetAbfss(): void;
    get abfssInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsAbfss[] | undefined;
    private _dbfs;
    get dbfs(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfsList;
    putDbfs(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfs[] | cdktf.IResolvable): void;
    resetDbfs(): void;
    get dbfsInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsDbfs[] | undefined;
    private _file;
    get file(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFileList;
    putFile(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFile[] | cdktf.IResolvable): void;
    resetFile(): void;
    get fileInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsFile[] | undefined;
    private _gcs;
    get gcs(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcsList;
    putGcs(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcs[] | cdktf.IResolvable): void;
    resetGcs(): void;
    get gcsInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsGcs[] | undefined;
    private _s3;
    get s3(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3List;
    putS3(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3[] | cdktf.IResolvable): void;
    resetS3(): void;
    get s3Input(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsS3[] | undefined;
    private _volumes;
    get volumes(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumesList;
    putVolumes(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumes[] | cdktf.IResolvable): void;
    resetVolumes(): void;
    get volumesInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsVolumes[] | undefined;
    private _workspace;
    get workspace(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspaceList;
    putWorkspace(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspace[] | cdktf.IResolvable): void;
    resetWorkspace(): void;
    get workspaceInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsWorkspace[] | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScripts[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClients {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#jobs DataDatabricksClusterPluginframework#jobs}
    */
    readonly jobs?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#notebooks DataDatabricksClusterPluginframework#notebooks}
    */
    readonly notebooks?: boolean | cdktf.IResolvable;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClientsToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClients): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClientsToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClients): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClientsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClients | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClients | undefined);
    private _jobs?;
    get jobs(): boolean | cdktf.IResolvable;
    set jobs(value: boolean | cdktf.IResolvable);
    resetJobs(): void;
    get jobsInput(): boolean | cdktf.IResolvable | undefined;
    private _notebooks?;
    get notebooks(): boolean | cdktf.IResolvable;
    set notebooks(value: boolean | cdktf.IResolvable);
    resetNotebooks(): void;
    get notebooksInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClientsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClients[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClientsOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadType {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#clients DataDatabricksClusterPluginframework#clients}
    */
    readonly clients: DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClients[] | cdktf.IResolvable;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadType | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadType | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadType | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadType | cdktf.IResolvable | undefined);
    private _clients;
    get clients(): DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClientsList;
    putClients(value: DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClients[] | cdktf.IResolvable): void;
    get clientsInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeClients[] | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadType[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoSpec {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#apply_policy_default_values DataDatabricksClusterPluginframework#apply_policy_default_values}
    */
    readonly applyPolicyDefaultValues?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#autoscale DataDatabricksClusterPluginframework#autoscale}
    */
    readonly autoscale?: DataDatabricksClusterPluginframeworkClusterInfoSpecAutoscale[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#autotermination_minutes DataDatabricksClusterPluginframework#autotermination_minutes}
    */
    readonly autoterminationMinutes?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#aws_attributes DataDatabricksClusterPluginframework#aws_attributes}
    */
    readonly awsAttributes?: DataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributes[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#azure_attributes DataDatabricksClusterPluginframework#azure_attributes}
    */
    readonly azureAttributes?: DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributes[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#cluster_log_conf DataDatabricksClusterPluginframework#cluster_log_conf}
    */
    readonly clusterLogConf?: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConf[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#cluster_name DataDatabricksClusterPluginframework#cluster_name}
    */
    readonly clusterName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#custom_tags DataDatabricksClusterPluginframework#custom_tags}
    */
    readonly customTags?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#data_security_mode DataDatabricksClusterPluginframework#data_security_mode}
    */
    readonly dataSecurityMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#docker_image DataDatabricksClusterPluginframework#docker_image}
    */
    readonly dockerImage?: DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImage[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#driver_instance_pool_id DataDatabricksClusterPluginframework#driver_instance_pool_id}
    */
    readonly driverInstancePoolId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#driver_node_type_id DataDatabricksClusterPluginframework#driver_node_type_id}
    */
    readonly driverNodeTypeId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#enable_elastic_disk DataDatabricksClusterPluginframework#enable_elastic_disk}
    */
    readonly enableElasticDisk?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#enable_local_disk_encryption DataDatabricksClusterPluginframework#enable_local_disk_encryption}
    */
    readonly enableLocalDiskEncryption?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#gcp_attributes DataDatabricksClusterPluginframework#gcp_attributes}
    */
    readonly gcpAttributes?: DataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributes[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#init_scripts DataDatabricksClusterPluginframework#init_scripts}
    */
    readonly initScripts?: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScripts[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#instance_pool_id DataDatabricksClusterPluginframework#instance_pool_id}
    */
    readonly instancePoolId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#is_single_node DataDatabricksClusterPluginframework#is_single_node}
    */
    readonly isSingleNode?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#kind DataDatabricksClusterPluginframework#kind}
    */
    readonly kind?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#node_type_id DataDatabricksClusterPluginframework#node_type_id}
    */
    readonly nodeTypeId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#num_workers DataDatabricksClusterPluginframework#num_workers}
    */
    readonly numWorkers?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#policy_id DataDatabricksClusterPluginframework#policy_id}
    */
    readonly policyId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#remote_disk_throughput DataDatabricksClusterPluginframework#remote_disk_throughput}
    */
    readonly remoteDiskThroughput?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#runtime_engine DataDatabricksClusterPluginframework#runtime_engine}
    */
    readonly runtimeEngine?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#single_user_name DataDatabricksClusterPluginframework#single_user_name}
    */
    readonly singleUserName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#spark_conf DataDatabricksClusterPluginframework#spark_conf}
    */
    readonly sparkConf?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#spark_env_vars DataDatabricksClusterPluginframework#spark_env_vars}
    */
    readonly sparkEnvVars?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#spark_version DataDatabricksClusterPluginframework#spark_version}
    */
    readonly sparkVersion?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#ssh_public_keys DataDatabricksClusterPluginframework#ssh_public_keys}
    */
    readonly sshPublicKeys?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#total_initial_remote_disk_size DataDatabricksClusterPluginframework#total_initial_remote_disk_size}
    */
    readonly totalInitialRemoteDiskSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#use_ml_runtime DataDatabricksClusterPluginframework#use_ml_runtime}
    */
    readonly useMlRuntime?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#workload_type DataDatabricksClusterPluginframework#workload_type}
    */
    readonly workloadType?: DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadType[] | cdktf.IResolvable;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpec | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoSpecToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoSpec | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoSpec | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoSpec | cdktf.IResolvable | undefined);
    private _applyPolicyDefaultValues?;
    get applyPolicyDefaultValues(): boolean | cdktf.IResolvable;
    set applyPolicyDefaultValues(value: boolean | cdktf.IResolvable);
    resetApplyPolicyDefaultValues(): void;
    get applyPolicyDefaultValuesInput(): boolean | cdktf.IResolvable | undefined;
    private _autoscale;
    get autoscale(): DataDatabricksClusterPluginframeworkClusterInfoSpecAutoscaleList;
    putAutoscale(value: DataDatabricksClusterPluginframeworkClusterInfoSpecAutoscale[] | cdktf.IResolvable): void;
    resetAutoscale(): void;
    get autoscaleInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecAutoscale[] | undefined;
    private _autoterminationMinutes?;
    get autoterminationMinutes(): number;
    set autoterminationMinutes(value: number);
    resetAutoterminationMinutes(): void;
    get autoterminationMinutesInput(): number | undefined;
    private _awsAttributes;
    get awsAttributes(): DataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributesList;
    putAwsAttributes(value: DataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributes[] | cdktf.IResolvable): void;
    resetAwsAttributes(): void;
    get awsAttributesInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecAwsAttributes[] | undefined;
    private _azureAttributes;
    get azureAttributes(): DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributesList;
    putAzureAttributes(value: DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributes[] | cdktf.IResolvable): void;
    resetAzureAttributes(): void;
    get azureAttributesInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecAzureAttributes[] | undefined;
    private _clusterLogConf;
    get clusterLogConf(): DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConfList;
    putClusterLogConf(value: DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConf[] | cdktf.IResolvable): void;
    resetClusterLogConf(): void;
    get clusterLogConfInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecClusterLogConf[] | undefined;
    private _clusterName?;
    get clusterName(): string;
    set clusterName(value: string);
    resetClusterName(): void;
    get clusterNameInput(): string | undefined;
    private _customTags?;
    get customTags(): {
        [key: string]: string;
    };
    set customTags(value: {
        [key: string]: string;
    });
    resetCustomTags(): void;
    get customTagsInput(): {
        [key: string]: string;
    } | undefined;
    private _dataSecurityMode?;
    get dataSecurityMode(): string;
    set dataSecurityMode(value: string);
    resetDataSecurityMode(): void;
    get dataSecurityModeInput(): string | undefined;
    private _dockerImage;
    get dockerImage(): DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImageList;
    putDockerImage(value: DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImage[] | cdktf.IResolvable): void;
    resetDockerImage(): void;
    get dockerImageInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecDockerImage[] | undefined;
    private _driverInstancePoolId?;
    get driverInstancePoolId(): string;
    set driverInstancePoolId(value: string);
    resetDriverInstancePoolId(): void;
    get driverInstancePoolIdInput(): string | undefined;
    private _driverNodeTypeId?;
    get driverNodeTypeId(): string;
    set driverNodeTypeId(value: string);
    resetDriverNodeTypeId(): void;
    get driverNodeTypeIdInput(): string | undefined;
    private _enableElasticDisk?;
    get enableElasticDisk(): boolean | cdktf.IResolvable;
    set enableElasticDisk(value: boolean | cdktf.IResolvable);
    resetEnableElasticDisk(): void;
    get enableElasticDiskInput(): boolean | cdktf.IResolvable | undefined;
    private _enableLocalDiskEncryption?;
    get enableLocalDiskEncryption(): boolean | cdktf.IResolvable;
    set enableLocalDiskEncryption(value: boolean | cdktf.IResolvable);
    resetEnableLocalDiskEncryption(): void;
    get enableLocalDiskEncryptionInput(): boolean | cdktf.IResolvable | undefined;
    private _gcpAttributes;
    get gcpAttributes(): DataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributesList;
    putGcpAttributes(value: DataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributes[] | cdktf.IResolvable): void;
    resetGcpAttributes(): void;
    get gcpAttributesInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecGcpAttributes[] | undefined;
    private _initScripts;
    get initScripts(): DataDatabricksClusterPluginframeworkClusterInfoSpecInitScriptsList;
    putInitScripts(value: DataDatabricksClusterPluginframeworkClusterInfoSpecInitScripts[] | cdktf.IResolvable): void;
    resetInitScripts(): void;
    get initScriptsInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecInitScripts[] | undefined;
    private _instancePoolId?;
    get instancePoolId(): string;
    set instancePoolId(value: string);
    resetInstancePoolId(): void;
    get instancePoolIdInput(): string | undefined;
    private _isSingleNode?;
    get isSingleNode(): boolean | cdktf.IResolvable;
    set isSingleNode(value: boolean | cdktf.IResolvable);
    resetIsSingleNode(): void;
    get isSingleNodeInput(): boolean | cdktf.IResolvable | undefined;
    private _kind?;
    get kind(): string;
    set kind(value: string);
    resetKind(): void;
    get kindInput(): string | undefined;
    private _nodeTypeId?;
    get nodeTypeId(): string;
    set nodeTypeId(value: string);
    resetNodeTypeId(): void;
    get nodeTypeIdInput(): string | undefined;
    private _numWorkers?;
    get numWorkers(): number;
    set numWorkers(value: number);
    resetNumWorkers(): void;
    get numWorkersInput(): number | undefined;
    private _policyId?;
    get policyId(): string;
    set policyId(value: string);
    resetPolicyId(): void;
    get policyIdInput(): string | undefined;
    private _remoteDiskThroughput?;
    get remoteDiskThroughput(): number;
    set remoteDiskThroughput(value: number);
    resetRemoteDiskThroughput(): void;
    get remoteDiskThroughputInput(): number | undefined;
    private _runtimeEngine?;
    get runtimeEngine(): string;
    set runtimeEngine(value: string);
    resetRuntimeEngine(): void;
    get runtimeEngineInput(): string | undefined;
    private _singleUserName?;
    get singleUserName(): string;
    set singleUserName(value: string);
    resetSingleUserName(): void;
    get singleUserNameInput(): string | undefined;
    private _sparkConf?;
    get sparkConf(): {
        [key: string]: string;
    };
    set sparkConf(value: {
        [key: string]: string;
    });
    resetSparkConf(): void;
    get sparkConfInput(): {
        [key: string]: string;
    } | undefined;
    private _sparkEnvVars?;
    get sparkEnvVars(): {
        [key: string]: string;
    };
    set sparkEnvVars(value: {
        [key: string]: string;
    });
    resetSparkEnvVars(): void;
    get sparkEnvVarsInput(): {
        [key: string]: string;
    } | undefined;
    private _sparkVersion?;
    get sparkVersion(): string;
    set sparkVersion(value: string);
    resetSparkVersion(): void;
    get sparkVersionInput(): string | undefined;
    private _sshPublicKeys?;
    get sshPublicKeys(): string[];
    set sshPublicKeys(value: string[]);
    resetSshPublicKeys(): void;
    get sshPublicKeysInput(): string[] | undefined;
    private _totalInitialRemoteDiskSize?;
    get totalInitialRemoteDiskSize(): number;
    set totalInitialRemoteDiskSize(value: number);
    resetTotalInitialRemoteDiskSize(): void;
    get totalInitialRemoteDiskSizeInput(): number | undefined;
    private _useMlRuntime?;
    get useMlRuntime(): boolean | cdktf.IResolvable;
    set useMlRuntime(value: boolean | cdktf.IResolvable);
    resetUseMlRuntime(): void;
    get useMlRuntimeInput(): boolean | cdktf.IResolvable | undefined;
    private _workloadType;
    get workloadType(): DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadTypeList;
    putWorkloadType(value: DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadType[] | cdktf.IResolvable): void;
    resetWorkloadType(): void;
    get workloadTypeInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpecWorkloadType[] | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoSpecList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoSpec[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoSpecOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoTerminationReason {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#code DataDatabricksClusterPluginframework#code}
    */
    readonly code?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#parameters DataDatabricksClusterPluginframework#parameters}
    */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#type DataDatabricksClusterPluginframework#type}
    */
    readonly type?: string;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoTerminationReasonToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoTerminationReason | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoTerminationReasonToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoTerminationReason | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoTerminationReasonOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoTerminationReason | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoTerminationReason | cdktf.IResolvable | undefined);
    private _code?;
    get code(): string;
    set code(value: string);
    resetCode(): void;
    get codeInput(): string | undefined;
    private _parameters?;
    get parameters(): {
        [key: string]: string;
    };
    set parameters(value: {
        [key: string]: string;
    });
    resetParameters(): void;
    get parametersInput(): {
        [key: string]: string;
    } | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoTerminationReasonList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoTerminationReason[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoTerminationReasonOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClients {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#jobs DataDatabricksClusterPluginframework#jobs}
    */
    readonly jobs?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#notebooks DataDatabricksClusterPluginframework#notebooks}
    */
    readonly notebooks?: boolean | cdktf.IResolvable;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClientsToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClients): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClientsToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClients): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClientsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClients | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClients | undefined);
    private _jobs?;
    get jobs(): boolean | cdktf.IResolvable;
    set jobs(value: boolean | cdktf.IResolvable);
    resetJobs(): void;
    get jobsInput(): boolean | cdktf.IResolvable | undefined;
    private _notebooks?;
    get notebooks(): boolean | cdktf.IResolvable;
    set notebooks(value: boolean | cdktf.IResolvable);
    resetNotebooks(): void;
    get notebooksInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClientsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClients[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClientsOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfoWorkloadType {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#clients DataDatabricksClusterPluginframework#clients}
    */
    readonly clients: DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClients[] | cdktf.IResolvable;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoWorkloadType | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfoWorkloadType | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfoWorkloadType | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfoWorkloadType | cdktf.IResolvable | undefined);
    private _clients;
    get clients(): DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClientsList;
    putClients(value: DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClients[] | cdktf.IResolvable): void;
    get clientsInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeClients[] | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfoWorkloadType[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeOutputReference;
}
export interface DataDatabricksClusterPluginframeworkClusterInfo {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#autoscale DataDatabricksClusterPluginframework#autoscale}
    */
    readonly autoscale?: DataDatabricksClusterPluginframeworkClusterInfoAutoscale[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#autotermination_minutes DataDatabricksClusterPluginframework#autotermination_minutes}
    */
    readonly autoterminationMinutes?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#aws_attributes DataDatabricksClusterPluginframework#aws_attributes}
    */
    readonly awsAttributes?: DataDatabricksClusterPluginframeworkClusterInfoAwsAttributes[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#azure_attributes DataDatabricksClusterPluginframework#azure_attributes}
    */
    readonly azureAttributes?: DataDatabricksClusterPluginframeworkClusterInfoAzureAttributes[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#cluster_cores DataDatabricksClusterPluginframework#cluster_cores}
    */
    readonly clusterCores?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#cluster_id DataDatabricksClusterPluginframework#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#cluster_log_conf DataDatabricksClusterPluginframework#cluster_log_conf}
    */
    readonly clusterLogConf?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConf[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#cluster_log_status DataDatabricksClusterPluginframework#cluster_log_status}
    */
    readonly clusterLogStatus?: DataDatabricksClusterPluginframeworkClusterInfoClusterLogStatus[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#cluster_memory_mb DataDatabricksClusterPluginframework#cluster_memory_mb}
    */
    readonly clusterMemoryMb?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#cluster_name DataDatabricksClusterPluginframework#cluster_name}
    */
    readonly clusterName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#cluster_source DataDatabricksClusterPluginframework#cluster_source}
    */
    readonly clusterSource?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#creator_user_name DataDatabricksClusterPluginframework#creator_user_name}
    */
    readonly creatorUserName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#custom_tags DataDatabricksClusterPluginframework#custom_tags}
    */
    readonly customTags?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#data_security_mode DataDatabricksClusterPluginframework#data_security_mode}
    */
    readonly dataSecurityMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#default_tags DataDatabricksClusterPluginframework#default_tags}
    */
    readonly defaultTags?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#docker_image DataDatabricksClusterPluginframework#docker_image}
    */
    readonly dockerImage?: DataDatabricksClusterPluginframeworkClusterInfoDockerImage[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#driver DataDatabricksClusterPluginframework#driver}
    */
    readonly driver?: DataDatabricksClusterPluginframeworkClusterInfoDriver[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#driver_instance_pool_id DataDatabricksClusterPluginframework#driver_instance_pool_id}
    */
    readonly driverInstancePoolId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#driver_node_type_id DataDatabricksClusterPluginframework#driver_node_type_id}
    */
    readonly driverNodeTypeId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#enable_elastic_disk DataDatabricksClusterPluginframework#enable_elastic_disk}
    */
    readonly enableElasticDisk?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#enable_local_disk_encryption DataDatabricksClusterPluginframework#enable_local_disk_encryption}
    */
    readonly enableLocalDiskEncryption?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#executors DataDatabricksClusterPluginframework#executors}
    */
    readonly executors?: DataDatabricksClusterPluginframeworkClusterInfoExecutors[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#gcp_attributes DataDatabricksClusterPluginframework#gcp_attributes}
    */
    readonly gcpAttributes?: DataDatabricksClusterPluginframeworkClusterInfoGcpAttributes[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#init_scripts DataDatabricksClusterPluginframework#init_scripts}
    */
    readonly initScripts?: DataDatabricksClusterPluginframeworkClusterInfoInitScripts[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#instance_pool_id DataDatabricksClusterPluginframework#instance_pool_id}
    */
    readonly instancePoolId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#is_single_node DataDatabricksClusterPluginframework#is_single_node}
    */
    readonly isSingleNode?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#jdbc_port DataDatabricksClusterPluginframework#jdbc_port}
    */
    readonly jdbcPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#kind DataDatabricksClusterPluginframework#kind}
    */
    readonly kind?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#last_restarted_time DataDatabricksClusterPluginframework#last_restarted_time}
    */
    readonly lastRestartedTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#last_state_loss_time DataDatabricksClusterPluginframework#last_state_loss_time}
    */
    readonly lastStateLossTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#node_type_id DataDatabricksClusterPluginframework#node_type_id}
    */
    readonly nodeTypeId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#num_workers DataDatabricksClusterPluginframework#num_workers}
    */
    readonly numWorkers?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#policy_id DataDatabricksClusterPluginframework#policy_id}
    */
    readonly policyId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#remote_disk_throughput DataDatabricksClusterPluginframework#remote_disk_throughput}
    */
    readonly remoteDiskThroughput?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#runtime_engine DataDatabricksClusterPluginframework#runtime_engine}
    */
    readonly runtimeEngine?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#single_user_name DataDatabricksClusterPluginframework#single_user_name}
    */
    readonly singleUserName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#spark_conf DataDatabricksClusterPluginframework#spark_conf}
    */
    readonly sparkConf?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#spark_context_id DataDatabricksClusterPluginframework#spark_context_id}
    */
    readonly sparkContextId?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#spark_env_vars DataDatabricksClusterPluginframework#spark_env_vars}
    */
    readonly sparkEnvVars?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#spark_version DataDatabricksClusterPluginframework#spark_version}
    */
    readonly sparkVersion?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#spec DataDatabricksClusterPluginframework#spec}
    */
    readonly spec?: DataDatabricksClusterPluginframeworkClusterInfoSpec[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#ssh_public_keys DataDatabricksClusterPluginframework#ssh_public_keys}
    */
    readonly sshPublicKeys?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#start_time DataDatabricksClusterPluginframework#start_time}
    */
    readonly startTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#state DataDatabricksClusterPluginframework#state}
    */
    readonly state?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#state_message DataDatabricksClusterPluginframework#state_message}
    */
    readonly stateMessage?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#terminated_time DataDatabricksClusterPluginframework#terminated_time}
    */
    readonly terminatedTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#termination_reason DataDatabricksClusterPluginframework#termination_reason}
    */
    readonly terminationReason?: DataDatabricksClusterPluginframeworkClusterInfoTerminationReason[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#total_initial_remote_disk_size DataDatabricksClusterPluginframework#total_initial_remote_disk_size}
    */
    readonly totalInitialRemoteDiskSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#use_ml_runtime DataDatabricksClusterPluginframework#use_ml_runtime}
    */
    readonly useMlRuntime?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#workload_type DataDatabricksClusterPluginframework#workload_type}
    */
    readonly workloadType?: DataDatabricksClusterPluginframeworkClusterInfoWorkloadType[] | cdktf.IResolvable;
}
export declare function dataDatabricksClusterPluginframeworkClusterInfoToTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfo | cdktf.IResolvable): any;
export declare function dataDatabricksClusterPluginframeworkClusterInfoToHclTerraform(struct?: DataDatabricksClusterPluginframeworkClusterInfo | cdktf.IResolvable): any;
export declare class DataDatabricksClusterPluginframeworkClusterInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksClusterPluginframeworkClusterInfo | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksClusterPluginframeworkClusterInfo | cdktf.IResolvable | undefined);
    private _autoscale;
    get autoscale(): DataDatabricksClusterPluginframeworkClusterInfoAutoscaleList;
    putAutoscale(value: DataDatabricksClusterPluginframeworkClusterInfoAutoscale[] | cdktf.IResolvable): void;
    resetAutoscale(): void;
    get autoscaleInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoAutoscale[] | undefined;
    private _autoterminationMinutes?;
    get autoterminationMinutes(): number;
    set autoterminationMinutes(value: number);
    resetAutoterminationMinutes(): void;
    get autoterminationMinutesInput(): number | undefined;
    private _awsAttributes;
    get awsAttributes(): DataDatabricksClusterPluginframeworkClusterInfoAwsAttributesList;
    putAwsAttributes(value: DataDatabricksClusterPluginframeworkClusterInfoAwsAttributes[] | cdktf.IResolvable): void;
    resetAwsAttributes(): void;
    get awsAttributesInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoAwsAttributes[] | undefined;
    private _azureAttributes;
    get azureAttributes(): DataDatabricksClusterPluginframeworkClusterInfoAzureAttributesList;
    putAzureAttributes(value: DataDatabricksClusterPluginframeworkClusterInfoAzureAttributes[] | cdktf.IResolvable): void;
    resetAzureAttributes(): void;
    get azureAttributesInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoAzureAttributes[] | undefined;
    private _clusterCores?;
    get clusterCores(): number;
    set clusterCores(value: number);
    resetClusterCores(): void;
    get clusterCoresInput(): number | undefined;
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    private _clusterLogConf;
    get clusterLogConf(): DataDatabricksClusterPluginframeworkClusterInfoClusterLogConfList;
    putClusterLogConf(value: DataDatabricksClusterPluginframeworkClusterInfoClusterLogConf[] | cdktf.IResolvable): void;
    resetClusterLogConf(): void;
    get clusterLogConfInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoClusterLogConf[] | undefined;
    private _clusterLogStatus;
    get clusterLogStatus(): DataDatabricksClusterPluginframeworkClusterInfoClusterLogStatusList;
    putClusterLogStatus(value: DataDatabricksClusterPluginframeworkClusterInfoClusterLogStatus[] | cdktf.IResolvable): void;
    resetClusterLogStatus(): void;
    get clusterLogStatusInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoClusterLogStatus[] | undefined;
    private _clusterMemoryMb?;
    get clusterMemoryMb(): number;
    set clusterMemoryMb(value: number);
    resetClusterMemoryMb(): void;
    get clusterMemoryMbInput(): number | undefined;
    private _clusterName?;
    get clusterName(): string;
    set clusterName(value: string);
    resetClusterName(): void;
    get clusterNameInput(): string | undefined;
    private _clusterSource?;
    get clusterSource(): string;
    set clusterSource(value: string);
    resetClusterSource(): void;
    get clusterSourceInput(): string | undefined;
    private _creatorUserName?;
    get creatorUserName(): string;
    set creatorUserName(value: string);
    resetCreatorUserName(): void;
    get creatorUserNameInput(): string | undefined;
    private _customTags?;
    get customTags(): {
        [key: string]: string;
    };
    set customTags(value: {
        [key: string]: string;
    });
    resetCustomTags(): void;
    get customTagsInput(): {
        [key: string]: string;
    } | undefined;
    private _dataSecurityMode?;
    get dataSecurityMode(): string;
    set dataSecurityMode(value: string);
    resetDataSecurityMode(): void;
    get dataSecurityModeInput(): string | undefined;
    private _defaultTags?;
    get defaultTags(): {
        [key: string]: string;
    };
    set defaultTags(value: {
        [key: string]: string;
    });
    resetDefaultTags(): void;
    get defaultTagsInput(): {
        [key: string]: string;
    } | undefined;
    private _dockerImage;
    get dockerImage(): DataDatabricksClusterPluginframeworkClusterInfoDockerImageList;
    putDockerImage(value: DataDatabricksClusterPluginframeworkClusterInfoDockerImage[] | cdktf.IResolvable): void;
    resetDockerImage(): void;
    get dockerImageInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoDockerImage[] | undefined;
    private _driver;
    get driver(): DataDatabricksClusterPluginframeworkClusterInfoDriverList;
    putDriver(value: DataDatabricksClusterPluginframeworkClusterInfoDriver[] | cdktf.IResolvable): void;
    resetDriver(): void;
    get driverInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoDriver[] | undefined;
    private _driverInstancePoolId?;
    get driverInstancePoolId(): string;
    set driverInstancePoolId(value: string);
    resetDriverInstancePoolId(): void;
    get driverInstancePoolIdInput(): string | undefined;
    private _driverNodeTypeId?;
    get driverNodeTypeId(): string;
    set driverNodeTypeId(value: string);
    resetDriverNodeTypeId(): void;
    get driverNodeTypeIdInput(): string | undefined;
    private _enableElasticDisk?;
    get enableElasticDisk(): boolean | cdktf.IResolvable;
    set enableElasticDisk(value: boolean | cdktf.IResolvable);
    resetEnableElasticDisk(): void;
    get enableElasticDiskInput(): boolean | cdktf.IResolvable | undefined;
    private _enableLocalDiskEncryption?;
    get enableLocalDiskEncryption(): boolean | cdktf.IResolvable;
    set enableLocalDiskEncryption(value: boolean | cdktf.IResolvable);
    resetEnableLocalDiskEncryption(): void;
    get enableLocalDiskEncryptionInput(): boolean | cdktf.IResolvable | undefined;
    private _executors;
    get executors(): DataDatabricksClusterPluginframeworkClusterInfoExecutorsList;
    putExecutors(value: DataDatabricksClusterPluginframeworkClusterInfoExecutors[] | cdktf.IResolvable): void;
    resetExecutors(): void;
    get executorsInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoExecutors[] | undefined;
    private _gcpAttributes;
    get gcpAttributes(): DataDatabricksClusterPluginframeworkClusterInfoGcpAttributesList;
    putGcpAttributes(value: DataDatabricksClusterPluginframeworkClusterInfoGcpAttributes[] | cdktf.IResolvable): void;
    resetGcpAttributes(): void;
    get gcpAttributesInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoGcpAttributes[] | undefined;
    private _initScripts;
    get initScripts(): DataDatabricksClusterPluginframeworkClusterInfoInitScriptsList;
    putInitScripts(value: DataDatabricksClusterPluginframeworkClusterInfoInitScripts[] | cdktf.IResolvable): void;
    resetInitScripts(): void;
    get initScriptsInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoInitScripts[] | undefined;
    private _instancePoolId?;
    get instancePoolId(): string;
    set instancePoolId(value: string);
    resetInstancePoolId(): void;
    get instancePoolIdInput(): string | undefined;
    private _isSingleNode?;
    get isSingleNode(): boolean | cdktf.IResolvable;
    set isSingleNode(value: boolean | cdktf.IResolvable);
    resetIsSingleNode(): void;
    get isSingleNodeInput(): boolean | cdktf.IResolvable | undefined;
    private _jdbcPort?;
    get jdbcPort(): number;
    set jdbcPort(value: number);
    resetJdbcPort(): void;
    get jdbcPortInput(): number | undefined;
    private _kind?;
    get kind(): string;
    set kind(value: string);
    resetKind(): void;
    get kindInput(): string | undefined;
    private _lastRestartedTime?;
    get lastRestartedTime(): number;
    set lastRestartedTime(value: number);
    resetLastRestartedTime(): void;
    get lastRestartedTimeInput(): number | undefined;
    private _lastStateLossTime?;
    get lastStateLossTime(): number;
    set lastStateLossTime(value: number);
    resetLastStateLossTime(): void;
    get lastStateLossTimeInput(): number | undefined;
    private _nodeTypeId?;
    get nodeTypeId(): string;
    set nodeTypeId(value: string);
    resetNodeTypeId(): void;
    get nodeTypeIdInput(): string | undefined;
    private _numWorkers?;
    get numWorkers(): number;
    set numWorkers(value: number);
    resetNumWorkers(): void;
    get numWorkersInput(): number | undefined;
    private _policyId?;
    get policyId(): string;
    set policyId(value: string);
    resetPolicyId(): void;
    get policyIdInput(): string | undefined;
    private _remoteDiskThroughput?;
    get remoteDiskThroughput(): number;
    set remoteDiskThroughput(value: number);
    resetRemoteDiskThroughput(): void;
    get remoteDiskThroughputInput(): number | undefined;
    private _runtimeEngine?;
    get runtimeEngine(): string;
    set runtimeEngine(value: string);
    resetRuntimeEngine(): void;
    get runtimeEngineInput(): string | undefined;
    private _singleUserName?;
    get singleUserName(): string;
    set singleUserName(value: string);
    resetSingleUserName(): void;
    get singleUserNameInput(): string | undefined;
    private _sparkConf?;
    get sparkConf(): {
        [key: string]: string;
    };
    set sparkConf(value: {
        [key: string]: string;
    });
    resetSparkConf(): void;
    get sparkConfInput(): {
        [key: string]: string;
    } | undefined;
    private _sparkContextId?;
    get sparkContextId(): number;
    set sparkContextId(value: number);
    resetSparkContextId(): void;
    get sparkContextIdInput(): number | undefined;
    private _sparkEnvVars?;
    get sparkEnvVars(): {
        [key: string]: string;
    };
    set sparkEnvVars(value: {
        [key: string]: string;
    });
    resetSparkEnvVars(): void;
    get sparkEnvVarsInput(): {
        [key: string]: string;
    } | undefined;
    private _sparkVersion?;
    get sparkVersion(): string;
    set sparkVersion(value: string);
    resetSparkVersion(): void;
    get sparkVersionInput(): string | undefined;
    private _spec;
    get spec(): DataDatabricksClusterPluginframeworkClusterInfoSpecList;
    putSpec(value: DataDatabricksClusterPluginframeworkClusterInfoSpec[] | cdktf.IResolvable): void;
    resetSpec(): void;
    get specInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoSpec[] | undefined;
    private _sshPublicKeys?;
    get sshPublicKeys(): string[];
    set sshPublicKeys(value: string[]);
    resetSshPublicKeys(): void;
    get sshPublicKeysInput(): string[] | undefined;
    private _startTime?;
    get startTime(): number;
    set startTime(value: number);
    resetStartTime(): void;
    get startTimeInput(): number | undefined;
    private _state?;
    get state(): string;
    set state(value: string);
    resetState(): void;
    get stateInput(): string | undefined;
    private _stateMessage?;
    get stateMessage(): string;
    set stateMessage(value: string);
    resetStateMessage(): void;
    get stateMessageInput(): string | undefined;
    private _terminatedTime?;
    get terminatedTime(): number;
    set terminatedTime(value: number);
    resetTerminatedTime(): void;
    get terminatedTimeInput(): number | undefined;
    private _terminationReason;
    get terminationReason(): DataDatabricksClusterPluginframeworkClusterInfoTerminationReasonList;
    putTerminationReason(value: DataDatabricksClusterPluginframeworkClusterInfoTerminationReason[] | cdktf.IResolvable): void;
    resetTerminationReason(): void;
    get terminationReasonInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoTerminationReason[] | undefined;
    private _totalInitialRemoteDiskSize?;
    get totalInitialRemoteDiskSize(): number;
    set totalInitialRemoteDiskSize(value: number);
    resetTotalInitialRemoteDiskSize(): void;
    get totalInitialRemoteDiskSizeInput(): number | undefined;
    private _useMlRuntime?;
    get useMlRuntime(): boolean | cdktf.IResolvable;
    set useMlRuntime(value: boolean | cdktf.IResolvable);
    resetUseMlRuntime(): void;
    get useMlRuntimeInput(): boolean | cdktf.IResolvable | undefined;
    private _workloadType;
    get workloadType(): DataDatabricksClusterPluginframeworkClusterInfoWorkloadTypeList;
    putWorkloadType(value: DataDatabricksClusterPluginframeworkClusterInfoWorkloadType[] | cdktf.IResolvable): void;
    resetWorkloadType(): void;
    get workloadTypeInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfoWorkloadType[] | undefined;
}
export declare class DataDatabricksClusterPluginframeworkClusterInfoList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksClusterPluginframeworkClusterInfo[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksClusterPluginframeworkClusterInfoOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework databricks_cluster_pluginframework}
*/
export declare class DataDatabricksClusterPluginframework extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "databricks_cluster_pluginframework";
    /**
    * Generates CDKTF code for importing a DataDatabricksClusterPluginframework resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksClusterPluginframework to import
    * @param importFromId The id of the existing DataDatabricksClusterPluginframework that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksClusterPluginframework to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.85.0/docs/data-sources/cluster_pluginframework databricks_cluster_pluginframework} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksClusterPluginframeworkConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatabricksClusterPluginframeworkConfig);
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    private _clusterInfo;
    get clusterInfo(): DataDatabricksClusterPluginframeworkClusterInfoList;
    putClusterInfo(value: DataDatabricksClusterPluginframeworkClusterInfo[] | cdktf.IResolvable): void;
    resetClusterInfo(): void;
    get clusterInfoInput(): cdktf.IResolvable | DataDatabricksClusterPluginframeworkClusterInfo[] | undefined;
    private _clusterName?;
    get clusterName(): string;
    set clusterName(value: string);
    resetClusterName(): void;
    get clusterNameInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
